/* Configuration */

/************* BORING LEGAL NOTICE *******************
**                                                  **
**  Assassins' Game (Semi-)Automatic Umpire System  **
**  ----------------------------------------------  **
**  Prerelease: Copyright 2000-2002 Edward M Nokes  **
**  This code may not be distributed in source or   **
**  executable form without the express consent of  **
**  the author, Edward M Nokes (emn23@cam.ac.uk).   **
**  The author accepts no responsibility or         **
**  liability for anything occurring as a result    **
**  of using this software, etc. etc.               **
**  ----------------------------------------------  **
*****************************************************/

/* Additional admin security code when changing others' passwords */
#define PWSECURE			"kfughksi7gdkmjhg,mj7ymrjmj7gfmjghfms7rgfjdfh"

/* Title of current game */
#define GAME				"Michaelmas 2002"

/* URL of cgi-bin into which code is compiled, and various useful URLs */
#define CGI_URL				"http://www.srcf.ucam.org/assassins/cgi-bin/2002-m/"
#define SKULL_URL			"http://www.srcf.ucam.org/assassins/img/skull.gif"
#define CROSS_URL			"http://www.srcf.ucam.org/assassins/img/cross.gif"
#define TICK_URL			"http://www.srcf.ucam.org/assassins/img/tick.gif"
#define WARN_URL			"http://www.srcf.ucam.org/assassins/img/warn.gif"

/* Dimensions of included images */
#define SKULL_SIZ			"border=0 width=34 height=34"
#define CROSS_SIZ			"border=0 width=34 height=34"
#define TICK_SIZ			"border=0 width=34 height=34"
#define WARN_SIZ			"border=0 width=34 height=34"

/* URL of index page for website */
#define NEWS_INDEX			"http://www.srcf.ucam.org/assassins/index.html"
#define NEWS_URL			"http://www.srcf.ucam.org/assassins/m02/gen/"
#define FRAG_URL			"frag/"

/* Pathnames to directories for non-CGI executables, CGI-executables, game data, and auto-gen HTML */
#define BIN_ROOT			"/societies/assassins/AutoUmpBin/2002-m/"
#define CGI_ROOT			"/societies/assassins/cgi-bin/2002-m/"
#define DATA_ROOT			"/societies/assassins/AutoUmpData/2002-m/"
#define NEWS_ROOT			"/societies/assassins/public_html/m02/gen/"
#define DOC_ROOT			"/societies/assassins/public_html/m02/doc/"

/* Day-of-year, Day-of-week, Day-of-month, Month, Year of start of game time (cannot handle anything before this date) */
#define StartingYDay		(284)
#define StartingWDay		(6)		/* Sat */
#define StartingMDay		(12)	/* 9th */
#define StartingMonth		(9)		/* Oct */
#define StartingYear		(2002)

/* Limits for date entry on forms -- NB, for safety's sake, should prevent day 0 from being used */
#define DAY_FullFirst		(5)
#define DAY_First			(6)
#define DAY_Last			(50)
#define DAY_FullLast		(60)
#define LAST_DAY			(50)
#define DAY_plinfoFirst		(5)		/* Cannot query earlier than 00:00 (exclusive) on this day */
#define DAY_plinfoLast		(50)	/* Cannot query later than 00:00 on this day */

/* Define to disallow event addition by non-admin players */
#define OPT_PubAddEvents	0
#define OPT_NoAddEvents		0
#define OPT_NoEditEvents	0

/* Resurrect players by default when killed? (don't define to disable automatic resurrection)
** Value is deadline day after which kill events will not automatically resurrect their victim */
/*#define DAY_AutoResLimit	(0)*/

/* Default scoring and dangerousness */
#define INITIAL_SCORE		(100L << SCORE_SHIFT)
#define INITIAL_DANGER		(0L << DANGER_SHIFT)
#define INITIAL_RANK		(0L)

/* Default inactivity period */
#define INACT_PERIOD		(7)

/* Default warning period before end of inactivity period */
#define INACT_WARNING		(5)

/* Email address and "from" header for auto-generated email */
#define MAILFROM			"rjw76@hermes.cam.ac.uk"
#define MAILFROM_head		"Michaelmas 2002 automatic umpire <" MAILFROM ">"
#define MAILDOMAIN			"@hermes.cam.ac.uk"

/* Allow player id selection by pseuds */
#define OPT_NoListPlayers	1
#define OPT_IDMenuMode		0
#define OPT_ChangePseud		1

/* Show scores */
#define OPT_ShowScore		1

/* Minimal and maximal allowable password lengths */
#define MIN_PasswordLen		6
#define MAX_PasswordLen		128

/* Maximal pseudonym length */
#define MAX_PseudLength		600
#define MAX_PseudDisplay	36			/* Limit on number of pseudonym chars to be displayed in forms */

/* Some colours */
#define BLUE	"#000055"
#define GREEN	"#005500"
#define RED		"#550000"
#define WHITE	"#FFFFFF"

/* How game time is divided up: news is placed on separate pages for each period (suffix gives filename suffix for each)
** Times are Day:Hour:Min offsets from the start of game time, ie. first period is 00:00:00 to 01:00:00 */
struct period { unsigned long tmax; char* index, *title; } periods[] =
{
	/***** DD:HH:MM  Suffix  Title *****/
	{ TMTV(5,23,59), "00", "Pre-game"  },
	{ TMTV(11,23,59), "01", "Days 1-5: Brian"     },
	{ TMTV(20,23,59), "02", "Day 6 onwards"     },
	{ TMTV(30,23,59), "03", "Week 3"     },
	{ TMTV(40,23,59), "04", "Week 4"     },
	{ TMAX         , "0x", "Post-game" }
};

/* Police ranks */
#define MAX_rank	12
#define DEF_rank	5

/* Rank names */
char* rank_name[MAX_rank+2] =
{
	"** Rank too low **",
	"Police tea-lady", /* rank 1 */
	"Traffic policeman",
	"Doughnut-buyer",
	"Dog-handler",
	"Constable",
	"Agent",
	"Officer",
	"Inspector",
	"Superintendant",
	"Chief-Constable",
	"Assissant Chief of Police",
	"Chief of Police",
	"** Rank too great **"
};

/* CGI page footers */
#define FOOTER	"Return to: <a href=\"" NEWS_INDEX "\">index</a>" \
				" | <a href=\""CGI_URL"stats.cgi\">stats</a>" \
				" | <a href=\""NEWS_URL"news01.html\">News 1</a>" \
				" | <a href=\""NEWS_URL"news02.html\">News 2</a>" \
				/*" | <a href=\""NEWS_URL"news03.html\">day 3</a>"*/ \
				/*" | <a href=\""NEWS_URL"news04.html\">day 4</a>"*/ \
				" &mdash; No news yet"

/* File versioning constants */
#define CHK_DIG_ver		2	/* Number of digits used for file version */	
#define CHK_DIG_parm	8
#define CHK_NoHeader	-1
#define CHK_VER			21	/* A (CHK_DIG_ver) decimal number for current version */
#define CHK_uinfo		0
#define CHK_events		1
#define CHK_reps		2
#define CHK_MAX			3

/* File versioning header info */
struct chk
{
	size_t len;
	char *str1, *str2, *str3;
}
chk[CHK_MAX] =
{
	{ 27,					"!uinfo-ver.",	"-m!02-header!\n",	0			 },	/* CHK_unifo */
	{ 32 + CHK_DIG_parm,	"!event-ver.",	"-m!02-idx.",		"-header!\n" },	/* CHK_events */
	{ 31 + CHK_DIG_parm,	"!reps-ver.",	"-m!02-idx.",		"-header!\n" }	/* CHK_reps */
};

/*** The End ***/
