/*****************************************************
**  lib-uinfo-misc.c                     (library)  **
**  ----------------------------------------------  **
**  Code for miscellaneous processing of uinfo.txt  **
**                                                  **
************** BORING LEGAL NOTICE *******************
**                                                  **
**  Assassins' Game (Semi-)Automatic Umpire System  **
**  ----------------------------------------------  **
**  Prerelease: Copyright 2000-2002 Edward M Nokes  **
**  This code may not be distributed in source or   **
**  executable form without the express consent of  **
**  the author, Edward M Nokes (emn23@cam.ac.uk).   **
**  The author accepts no responsibility or         **
**  liability for anything occurring as a result    **
**  of using this software, etc. etc.               **
**                                                  **
*****************************************************/

#ifdef included__lib_uinfo_misc
 #error "** lib-uinfo-misc multiply #included **"
#else
 #define included__lib_uinfo_misc fromfile

#ifndef included__lib_uinfo_read
 #include "!lib-uinfo-read.c"
#endif

/***************************************************************************************************************************
** Definitions and declarations                                                                                           **
***************************************************************************************************************************/


/***************************************************************************************************************************
** Build a <form><select>-style list of players from 'uinfo' file. Output is in form "<option value="id">name</option>".  **
** The defauly id selected is specificed by (whom); set it to null for no-one. (mask) and (test) are used to test flags.  **
***************************************************************************************************************************/
#ifdef MAX_fpbuf
struct makeidmenu__ctx
{
	char *whom;
	unsigned long mask, test;
	int mode;
};

int makeidmenu__func(player_p pptr, int state, void* context)
{
	struct makeidmenu__ctx* ctx = context;
	char* p;

	/* Presentation criteria */
	if ((pptr->flags & ctx->mask) != (ctx->test)) return 1;

	/* Default? */
	p = ((ctx->whom) && (streq(ctx->whom, pptr->id))) ? "selected " : "";

	/* Output option HTML */
	printf("<option %svalue=\"%s\">", p, pptr->id);

	p = (ctx->mode & 1) ? pptr->pseud : pptr->name;

	if (p) encapsulate(p, stdout);

	else puts("[**NoPseud**]");

	puts("</option>");

	/* Handle all players */
	return 1;
}

int makeidmenu(char* whom, unsigned long mask, unsigned long test, int mode)
{
	struct makeidmenu__ctx ctx;

	/* Set up context */
	ctx.whom = whom;
	ctx.mask = mask;
	ctx.test = test;
	ctx.mode = mode;

	/* Build the list */
	return uread(0, makeidmenu__func, 0, fpbuf, fpend, 0, &ctx, 0);
}
#endif

/***************************************************************************************************************************
**                                                                                                                        **
***************************************************************************************************************************/

#endif
/*** The End ***/
