/* Configuration */

#ifdef BODGE
 #define TMPGAME "2003-test/"
 #define TMPTHING "test"
#else
 #define TMPGAME "2003-m/"
 #define TMPTHING "m03"
#endif

/************* BORING LEGAL NOTICE *******************
**                                                  **
**  Assassins' Game (Semi-)Automatic Umpire System  **
**  ----------------------------------------------  **
**  Prerelease: Copyright 2000-2002 Edward M Nokes  **
**  This code may not be distributed in source or   **
**  executable form without the express consent of  **
**  the author, Edward M Nokes (emn23@cam.ac.uk).   **
**  The author accepts no responsibility or         **
**  liability for anything occurring as a result    **
**  of using this software, etc. etc.               **
**  ----------------------------------------------  **
*****************************************************/

/* Additional admin security code when changing others' passwords */
#define PWSECURE			"GSedmIkGGyl9jfN"

/* Title of current game */
#define GAME				"Michaelmas 2003"

/* URL of cgi-bin into which code is compiled, and various useful URLs */
#define CGI_URL				"http://www.srcf.ucam.org/assassins/cgi-bin/" TMPGAME
#define SKULL_URL			"http://www.srcf.ucam.org/assassins/img/skull.gif"
#define CROSS_URL			"http://www.srcf.ucam.org/assassins/img/cross.gif"
#define TICK_URL			"http://www.srcf.ucam.org/assassins/img/tick.gif"
#define WARN_URL			"http://www.srcf.ucam.org/assassins/img/warn.gif"

/* Dimensions of included images */
#define SKULL_SIZ			"border=0 width=34 height=34"
#define CROSS_SIZ			"border=0 width=34 height=34"
#define TICK_SIZ			"border=0 width=34 height=34"
#define WARN_SIZ			"border=0 width=34 height=34"

/* URL of index page for website */
#define NEWS_INDEX			"http://www.srcf.ucam.org/assassins/index.html"
#define NEWS_URL			"http://www.srcf.ucam.org/assassins/this/"
#define FRAG_URL			"frag/"

/* Pathnames to directories for non-CGI executables, CGI-executables, game data, and auto-gen HTML */
#define BIN_ROOT			"/societies/assassins/AutoUmpBin/" TMPGAME
#define CGI_ROOT			"/societies/assassins/cgi-bin/" TMPGAME
#define DATA_ROOT			"/societies/assassins/AutoUmpData/" TMPGAME
#define NEWS_ROOT			"/societies/assassins/public_html/" TMPTHING "gen/"
#define DOC_ROOT			"/societies/assassins/public_html/" TMPTHING "doc/"

/* Day-of-year, Day-of-week, Day-of-month, Month, Year of start of game time (cannot handle anything before this date) */
#define StartingYDay		(291)
#define StartingWDay		(0)		/* Sun */
#define StartingMDay		(19)	/* 19th */
#define StartingMonth		(9)		/* Oct */
#define StartingYear		(2003)

/* Limits for date entry on forms -- NB, for safety's sake, should prevent day 0 from being used */
#define DAY_FullFirst		(0)
#define DAY_First			(0)
#define DAY_Last			(50)
#define DAY_FullLast		(60)
#define LAST_DAY			(50)
#define DAY_plinfoFirst		(0)		/* Cannot query earlier than 00:00 (exclusive) on this day */
#define DAY_plinfoLast		(50)	/* Cannot query later than 00:00 on this day */

/* Clamps for date selectors (inclusive min and max) */
#define TIME_DateSelFullMin	TVAL(0,0,0)
#define TIME_DateSelMin		TVAL(0,22,0)
#define TIME_DateSelMax		TVAL(49,99,99)
#define TIME_DateSelFullMax	TVAL(59,99,99)
#define TIME_pledFullMin	TVAL(0,0,0)
#define TIME_pledMin		TVAL(0,22,0)
#define TIME_pledMax		TVAL(49,99,99)
#define TIME_pledFullMax	TVAL(59,99,99)
#define TIME_eventFullMin	TVAL(0,0,0)
#define TIME_eventMin		TVAL(0,22,0)
#define TIME_eventMax		TVAL(49,99,99)
#define TIME_eventFullMax	TVAL(59,99,99)
#define TIME_plinfoMin		TVAL(0,22,0)
#define TIME_plinfoMax		TVAL(49,99,99)
#define TIME_genstatsMin	TVAL(0,0,0)
#define TIME_genstatsMax	TVAL(50,0,0)
#define TIME_chstatsMin		TVAL(0,0,0)

/* Default warning period before end of inactivity period */
/* #define INACT_WARNING	(5) */
#define HOURS_InactWarning	(2*24)

/* Define to disallow event addition by non-admin players */
#define OPT_PubAddEvents	0
#define OPT_NoAddEvents		0
#define OPT_NoEditEvents	0

/* Randomise by default on some retargettings */
#define OPT_DefRandomTarg	1

/* Resurrect players by default when killed? (don't define to disable automatic resurrection)
** Value is deadline day after which kill events will not automatically resurrect their victim */
/* #define DAY_AutoResLimit		(0)*/
/* #define TIME_AutoResLimit	TVAL(0,0,0) */

/* Default scoring and dangerousness */
#define INITIAL_SCORE		(100L << SCORE_SHIFT)
#define INITIAL_DANGER		(0L << DANGER_SHIFT)
#define INITIAL_RANK		(0L)

/* Default inactivity period */
#define INACT_PERIOD		(7)
#define DEF_BOOST		(7)

/* Email address and "from" header for auto-generated email */
#define MAILFROM			"assassins@cusu.cam.ac.uk"
#define MAILFROM_head		"The Umpire <" MAILFROM ">"
#define MAILDOMAIN			"@hermes.cam.ac.uk"

/* Allow player id selection by pseuds */
#define OPT_NoListPlayers	1
#define OPT_IDMenuMode		0
#define OPT_ChangePseud		1

/* Show scores */
#define OPT_ShowScore		0

/* Minimal and maximal allowable password lengths */
#define MIN_PasswordLen		6
#define MAX_PasswordLen		128

/* Maximal pseudonym length */
#define MAX_PseudLength		600
#define MAX_PseudDisplay	36			/* Limit on number of pseudonym chars to be displayed in forms */

/* Some colours */
#define BLUE	"#000055"
#define GREEN	"#005500"
#define RED		"#550000"
#define WHITE	"#FFFFFF"

/* How game time is divided up: news is placed on separate pages for each period (suffix gives filename suffix for each)
** Times are Day:Hour:Min offsets from the start of game time, ie. first period is 00:00:00 to 01:00:00 */
struct period { timeval tmax; char* index, *title; } periods[] =
{
	/***** DD:HH:MM  Suffix  Title *****/
	{ TMIN          , "__", "**[invalid]**"},
	{ TVAL( 0,12,00), "00", "Pre-game" },
	{ TVAL( 7,23,59), "01", "Week one" },
	{ TVAL(14,18,59), "02", "Days 8-14" },
	{ TVAL(21,23,59), "03", "Days 12-15" },
	{ TVAL(27,23,59), "04", "Days 16-22" },
	{ TVAL(40,23,59), "05", "Days 23-35 " },
	{ TVAL(80,23,59), "06", "Day 36 onwards" },
	{ TMAX          , "0x", "Post-game" }
};

/* Police ranks */
#define MAX_rank	16
#define DEF_rank	5

/* Rank names */
char* rank_name[MAX_rank+2] =
{
	"** Rank too low **",
	"Police tea-lady", /* rank 1 */
	"Work experience lad",
	"Doughnut-buyer",
	"Dog-handler",
	"Constable",
	"Agent",
	"Special Agent",
	"Sergeant",
	"Officer",
	"Inspector",
	"Superintendent",
	"Acting Deputy Chief of Police",
	"Senior Anti-Corruption Officer",
	"Deputy Chief of Police",
	"Acting Chief of Police",
	"Chief of Police",
	"** Rank too great **"
};

/* CGI page footers */
#define FOOTER	"Return to: <a href=\"" NEWS_INDEX "\">index</a>" \
				" | <a href=\""CGI_URL"stats.cgi\">stats</a>" \
				" | <a href=\""NEWS_URL"news01.html\">News 1</a>" \
				" | <a href=\""NEWS_URL"news02.html\">News 2</a>" \
				" | <a href=\""NEWS_URL"news03.html\">News 3</a>" \
				" | <a href=\""NEWS_URL"news04.html\">News 4</a>" \
				" | <a href=\""NEWS_URL"news05.html\">News 5</a>" \
				" | <a href=\""NEWS_URL"news06.html\">News 6</a>" \
				" &mdash; No news yet"

/* File versioning constants */
#define CHK_DIG_ver		2	/* Number of digits used for file version */	
#define CHK_DIG_parm	8
#define CHK_NoHeader	-1
#define CHK_VER			25	/* A (CHK_DIG_ver) decimal number for current version */
#define CHK_uinfo		0
#define CHK_events		1
#define CHK_reps		2
#define CHK_MAX			3

/* File versioning header info */
struct chk
{
	size_t len;
	char *str1, *str2, *str3;
}
chk[CHK_MAX] =
{
	{ 27,					"!uinfo-ver.",	"-l!03-header!\n",	0			 },	/* CHK_unifo */
	{ 32 + CHK_DIG_parm,	"!event-ver.",	"-l!03-idx.",		"-header!\n" },	/* CHK_events */
	{ 31 + CHK_DIG_parm,	"!reps-ver.",	"-l!03-idx.",		"-header!\n" }	/* CHK_reps */
};

/*** The End ***/
