
/* Some useful types -- not universally used, yet */
typedef unsigned char byte;
typedef unsigned short u16b;
typedef unsigned long u32b;
typedef size_t indx;

/* Maxima for these types */
#define byte_MAX UCHAR_MAX
#define u16b_MAX USHRT_MAX
#define u32b_MAX ULONG_MAX

/***************************
**  Acorn/RISC OS system  **
***************************/
#ifdef ACORN

	typedef unsigned long ulong;
	typedef unsigned int uint;

	/* Acorn specific code (replacements for libraries below) */
	#include "acorn.h"

/*****************************************
**  Unixoid systems - check endianness  **
*****************************************/
#else

	/* Libraries */
	#include <sys/types.h>
	#include <sys/stat.h>
	#include <sys/file.h>
	#include <unistd.h>
	#include <fcntl.h>
	
#endif

