/************* BORING LEGAL NOTICE *******************
**                                                  **
**  Assassins' Game (Semi-)Automatic Umpire System  **
**  ----------------------------------------------  **
**  Prerelease: Copyright 2000-2002 Edward M Nokes  **
**  This code may not be distributed in source or   **
**  executable form without the express consent of  **
**  the author, Edward M Nokes (emn23@cam.ac.uk).   **
**  The author accepts no responsibility or         **
**  liability for anything occurring as a result    **
**  of using this software, etc. etc.               **
**  ----------------------------------------------  **
*****************************************************/

#define MAX_fpbuf			256*1024
#define MAX_buf				2*1024*1024
#define MAX_hbuf			2048
#define MAX_cb				64

#ifdef http
 #define MAX_npairs 		10
 #define MAX_cgibuf 		65536
#else
 #define NO_CGI
#endif

#define CAT_Player				(1)
#define CAT_Wanted				(2)
#define CAT_Police				(3)
#define CAT_Incomp				(4)
#define MAX_scoretab			(5)

#define EVENT_EXT_TYPE		int			/* type of  event_p->ext is irrelevent */
#define PLAYER_EXT_TYPE		pstate_p	/* type of player_p->ext is pstate_p   */
#define PSTATE_EXT_TYPE		appear_p	/* type of pstate_p->ext is appear_p   */
#define PSTATE_PLP_TYPE		player_p	/* type of pstate_p->plp is player_p   */
#define PEXIST_EXT_TYPE		int			/* type of pexist_p->ext is irrelevent */

#define EVOLVE_ALLOW_EXT_BACKLINKS		/* since PLAYER_EXT_TYPE is compatible */

typedef struct appear* appear_p;

#include "!lib-general.c"
#include "!custom.c"
#include "!lib-uinfo-read.c"
#include "!lib-evolve.c"
#include "!lib-rep-read.c"

#define IFDEB if (mode & MODE_Debug)
#define IFWARN if (mode & MODE_Warn)

/*#undef NEWS_ROOT*/
/*#define NEWS_ROOT "/home/societies/assassins/public_html/mw/test/"*/

/***************************************************************************************************************************
** HTML fragments                                                                                                         **
***************************************************************************************************************************/

/* Creamy */
/* #define FCOL				"#000000"
   #define UMPCOL			"#001144"
   #define COMCOL			"#441100"
   #define XXXCOL			"#FF00FF"
   #define COLSCHEME		"bgcolor=#ffffdd text=#000000 link=#0000FF vlink=#7700FF alink=#FF00FF"
*/

/* Black */
#define COLSCHEME		"bgcolor=#000000 text=#FFFFFF link=#FFCCFF vlink=#FFFFDD alink=#DDFFFF"
#define FCOL			"FFFFFF"
#define UMPCOL			"#FFFF00"
#define COMCOL			"#FFFF00"
#define XXXCOL			"#FF00FF"

#define FRAG_DEFAULT_MAIN_REPORT	"<h3>([d0]) Moo </h3>[Z]"

#define FRAG_DEFAULT_MAIN_ASSREP	"<h3>([d0]) [P1] [t] [P2]</h3>[Z]"

#define FRAG_DEFAULT_MAIN_KILLREP	"<h3>([d0]) [P1] [t] [P2] ([n2])</h3>[Z]"

#define FRAG_HEADLINE_HTML_HEADER \
	LF "<HTML><HEAD><TITLE>" GAME " Game Headlines</TITLE></HEAD>"\
	LF "<BODY " COLSCHEME ">"\
	LF "<h1><hr>" GAME " Game Headlines<hr></h1>"\
	LF /*"<!--#include file=\"" FRAG_URL "nhead1.txt\" -->"*/

#define FRAG_HEADLINE_HTML_FOOTER \
	LF /*"<!--#include file=\"" FRAG_URL "nhead2.txt\" -->"*/

#define FRAG_UPDATES_HTML_HEADER \
	LF "<HTML><HEAD><TITLE>" GAME " Game Updates</TITLE></HEAD>"\
	LF "<BODY " COLSCHEME ">"\
	LF "<h1><hr>" GAME " Game Updates<hr></h1>"\
	LF /*"<!--#include file=\"" FRAG_URL "nchg1.txt\" -->"*/

#define FRAG_UPDATES_HTML_FOOTER \
	LF /*"<!--#include file=\"" FRAG_URL "nchg2.txt\" -->"*/

#define FRAG_POLICE_HTML_HEADER \
	LF "<HTML><HEAD><TITLE>" GAME " Police List</TITLE></HEAD>"\
	LF "<BODY " COLSCHEME ">"\
	LF "<h1><hr>" GAME " Police List<hr></h1>"\
	LF "<!--#include file=\"" FRAG_URL "npol1.txt\" -->"

#define FRAG_POLICE_HTML_FOOTER \
	LF "<p></p>"

#define FRAG_INCOMP_HTML_HEADER \
	LF "<HTML><HEAD><TITLE>" GAME " Incompetents' List</TITLE></HEAD>"\
	LF "<BODY " COLSCHEME ">"\
	LF "<h1><hr>" GAME " Incompetents' List<hr></h1>"\
	LF "<!--#include file=\"" FRAG_URL "ninc1.txt\" -->"

#define FRAG_INCOMP_HTML_FOOTER \
	LF "<p></p>"

#define FRAG_WANTED_HTML_HEADER \
	LF "<HTML><HEAD><TITLE>" GAME " Wanted List</TITLE></HEAD>"\
	LF "<BODY " COLSCHEME ">"\
	LF "<h1><hr>" GAME " Wanted List<hr></h1>"\
	LF "<!--#include file=\"" FRAG_URL "nwant1.txt\" -->"

#define FRAG_WANTED_HTML_FOOTER \
	LF "<p></p>"

/***************************************************************************************************************************
** Definitions and declarations                                                                                           **
***************************************************************************************************************************/

/* Flags for report processing routines */
typedef unsigned long subst_mode;

#define SUBST_Specifics			((subst_mode) (1<<0))	/* Setup appearance [0] from report pointer */
#define SUBST_Main				((subst_mode) (1<<1))	/* Is the main report? May adjust appearance if so */
#define SUBST_InputReps			((subst_mode) (1<<2))	/* Automatically setup input context from report pointer */
#define SUBST_Introduce			((subst_mode) (1<<3))	/* Print introduction/byline to report */
#define SUBST_RestrictTags		((subst_mode) (1<<4))	/* XXX - unused */
#define SUBST_NoDirectives		((subst_mode) (1<<5))	/* Ignore all [] directives in input */
#define SUBST_Encapsulate		((subst_mode) (1<<6))	/* Don't process input, just encapsulate it into output */
#define SUBST_AllowNesting		((subst_mode) (1<<7))	/* Allow the [Z] report nesting directive to work */
#define SUBST_NoColourChange	((subst_mode) (1<<8))	/* Disable explicit [f#] colour change directives */
#define SUBST_HeadHack			((subst_mode) (1<<9))	/* Assume HTML paragraph already opened: don't insert <p> tag */
#define SUBST_Priv				((subst_mode) (1<<10))	/* Can change subst_mode, and use priv'd directives */
#define SUBST_Verbatim			((subst_mode) (1<<11))	/* Output report text directly without any processing */
#define SUBST_RepFlags			((subst_mode) (1<<12))	/* Automatically setup SUBST_mode flags from report flags */

/* General program flags */
typedef unsigned int mode_type;

#define MODE_CGI				((mode_type)(1<<0))
#define MODE_POL				((mode_type)(1<<1))
#define MODE_HEAD				((mode_type)(1<<2))
#define MODE_WANT				((mode_type)(1<<3))
#define MODE_NEWS				((mode_type)(16+32))
#define MODE_NewsToFiles		((mode_type)(16))
#define MODE_NewsOnStdout		((mode_type)(1<<5))
#define MODE_Priv				((mode_type)(1<<6))
#define MODE_CHANGES			((mode_type)(1<<7))
#define MODE_INCOMP				((mode_type)(1<<8))
#define MODE_FRAGMENT			((mode_type)(1<<9))
#define MODE_SCORES				((mode_type)(1<<10))
#define MODE_EvLink				((mode_type)(1<<11))
#define MODE_Accurate			((mode_type)(1<<12))
#define MODE_Warn				((mode_type)(1<<13))
#define MODE_Debug				((mode_type)(1<<14))

/* Structure to hold stored headlines */
struct headln
{
	char* eref, *head;
	timeval time, etim;
	struct headln* link;
};

/* Structure to hold report presentation information for a player */
struct appear
{
	pstate_p pstp;
	player_p pptr;
	char *colour, *pseud, *name;
};

/* Buffer for headline construction */
static char hbuf[MAX_hbuf+1];
char *thetimestr = "woo";

/* General variables */
static mode_type mode = 0;
static FILE *freps = 0;

/* Heads of player, player-state, report, saved-headline lists */
static player_p plist = 0;
static pstate_p pstlist = 0;
static report_p replist = 0;
static struct headln* headbase = 0;

/* Colours for event participants */
#define MAX_COLS SCDEF_MAX_Cols * 3
char* typecoltab[MAX_COLS] = 
{
	/* Dark */
	
	"#8888FF",	/* (ass) SCDEF_Comp_Norm_Ass    */        
	"#8888FF",	/* (ass) SCDEF_Inco_Norm_Ass    (error) */
	"#8888FF",	/* (ass) SCDEF_Comp_Want_Ass    */        
	"#8888FF",	/* (ass) SCDEF_Inco_Want_Ass    */        
	"#8888FF",	/* (ass) SCDEF_Comp_Norm_Pol    */        
	"#8888FF",	/* (ass) SCDEF_Inco_Norm_Pol    (error) */
	"#8888FF",	/* (ass) SCDEF_Comp_Want_Pol    */        
	"#8888FF",	/* (ass) SCDEF_Inco_Want_Pol    */
	"#FFFFFF",	/* (ass) SCDEF_LegalNonPlayer   */
	"#FFFFFF",	/* (ass) SCDEF_IllegalNonPlayer */
	"#FFFF00",	/* (ass) SCDEF_Special          */
	"#FFFF00",	/* (ass) SCDEF_Unknown          */
	"#FFFF00",	/* (ass) SCDEF_None             */

	"#88FF88",	/* (sur) SCDEF_Comp_Norm_Ass    */        
	"#88FF88",	/* (sur) SCDEF_Inco_Norm_Ass    (error) */
	"#88FF88",	/* (sur) SCDEF_Comp_Want_Ass    */        
	"#88FF88",	/* (sur) SCDEF_Inco_Want_Ass    */        
	"#88FF88",	/* (sur) SCDEF_Comp_Norm_Pol    */        
	"#88FF88",	/* (sur) SCDEF_Inco_Norm_Pol    (error) */
	"#88FF88",	/* (sur) SCDEF_Comp_Want_Pol    */        
	"#88FF88",	/* (sur) SCDEF_Inco_Want_Pol    */
	"#FFFFFF",	/* (sur) SCDEF_LegalNonPlayer   */
	"#FFFFFF",	/* (sur) SCDEF_IllegalNonPlayer */
	"#FFFF00",	/* (sur) SCDEF_Special          */
	"#FFFF00",	/* (sur) SCDEF_Unknown          */
	"#FFFF00",	/* (sur) SCDEF_None             */

	"#FF8888",	/* (kil) SCDEF_Comp_Norm_Ass    */        
	"#FF8888",	/* (kil) SCDEF_Inco_Norm_Ass    (error) */
	"#FF8888",	/* (kil) SCDEF_Comp_Want_Ass    */        
	"#FF8888",	/* (kil) SCDEF_Inco_Want_Ass    */        
	"#FF8888",	/* (kil) SCDEF_Comp_Norm_Pol    */        
	"#FF8888",	/* (kil) SCDEF_Inco_Norm_Pol    (error) */
	"#FF8888",	/* (kil) SCDEF_Comp_Want_Pol    */        
	"#FF8888",	/* (kil) SCDEF_Inco_Want_Pol    */
	"#DDDDFF",	/* (kil) SCDEF_LegalNonPlayer   */
	"#DDDDFF",	/* (kil) SCDEF_IllegalNonPlayer */
	"#FFFF00",	/* (kil) SCDEF_Special          */
	"#FFFF00",	/* (kil) SCDEF_Unknown          */
	"#FFFF00"	/* (kil) SCDEF_None             */
	
	/* Creamy */

#if 0
	"#009425",	/* (ass) SCDEF_Comp_Norm_Ass    */        
	"#A9A92D",	/* (ass) SCDEF_Inco_Norm_Ass    (error) */
	"#FF0000",	/* (ass) SCDEF_Comp_Want_Ass    */        
	"#A9A92D",	/* (ass) SCDEF_Inco_Want_Ass    */        
	"#0000FF",	/* (ass) SCDEF_Comp_Norm_Pol    */        
	"#06969E",	/* (ass) SCDEF_Inco_Norm_Pol    (error) */
	"#9D6954",	/* (ass) SCDEF_Comp_Want_Pol    */        
	"#06969E",	/* (ass) SCDEF_Inco_Want_Pol    */
	"#000000",	/* (ass) SCDEF_LegalNonPlayer   */
	"#000000",	/* (ass) SCDEF_IllegalNonPlayer */
	"#FFFF00",	/* (ass) SCDEF_Special          */
	"#FFFF00",	/* (ass) SCDEF_Unknown          */
	"#FFFF00",	/* (ass) SCDEF_None             */

	"#FF06C1",	/* (sur) SCDEF_Comp_Norm_Ass    */        
	"#FF06C1",	/* (sur) SCDEF_Inco_Norm_Ass    (error) */
	"#FF06C1",	/* (sur) SCDEF_Comp_Want_Ass    */        
	"#FF06C1",	/* (sur) SCDEF_Inco_Want_Ass    */        
	"#0000FF",	/* (sur) SCDEF_Comp_Norm_Pol    */        
	"#0000FF",	/* (sur) SCDEF_Inco_Norm_Pol    (error) */
	"#0000FF",	/* (sur) SCDEF_Comp_Want_Pol    */        
	"#0000FF",	/* (sur) SCDEF_Inco_Want_Pol    */
	"#00AA00",	/* (sur) SCDEF_LegalNonPlayer   */
	"#00AA00",	/* (sur) SCDEF_IllegalNonPlayer */
	"#FFFF00",	/* (sur) SCDEF_Special          */
	"#FFFF00",	/* (sur) SCDEF_Unknown          */
	"#FFFF00",	/* (sur) SCDEF_None             */

	"#BB0000",	/* (kil) SCDEF_Comp_Norm_Ass    */        
	"#AA00AA",	/* (kil) SCDEF_Inco_Norm_Ass    (error) */
	"#AA00AA",	/* (kil) SCDEF_Comp_Want_Ass    */        
	"#AA00AA",	/* (kil) SCDEF_Inco_Want_Ass    */        
	"#981DA9",	/* (kil) SCDEF_Comp_Norm_Pol    */        
	"#981DA9",	/* (kil) SCDEF_Inco_Norm_Pol    (error) */
	"#981DA9",	/* (kil) SCDEF_Comp_Want_Pol    */        
	"#981DA9",	/* (kil) SCDEF_Inco_Want_Pol    */
	"#222200",	/* (kil) SCDEF_LegalNonPlayer   */
	"#222200",	/* (kil) SCDEF_IllegalNonPlayer */
	"#FFFF00",	/* (kil) SCDEF_Special          */
	"#FFFF00",	/* (kil) SCDEF_Unknown          */
	"#FFFF00"	/* (kil) SCDEF_None             */
#endif
};

/* Colours for witnesses (allocated cyclically) */
char* witcoltab[] =
{
    /* Black as the ace of spades */
	"#BBBBBB", "#DDDDBB", "#BBDDDD",

	/* Creamy goodness */
	/* "#333333", "#222244", "#442222", */

	0
};

/* Allowed tags: ordering is important: must go "/tag","tag" for correct monitoring. */
#define MAX_tags 50
char* tags[MAX_tags] =
{
	"/p", "p", "/h1", "h1", "/h2", "h2", "/h3", "h3", "/h4", "h4", "/h5", "h5", "/h6", "h6", "/h7", "h7",
	"/blockquote", "blockquote", "/ul", "ul", "/ol", "ol", "/pre", "pre",
	#define MAX_tags_block 24   /* ^^^ Block-scope tags ^^^ */
	"/b", "b", "/i", "i", "/li", "li", "/tt", "tt", "/code", "code", "/em", "em", "/sup", "sup", "/sub", "sub",
	"", "img", "", "br", "", "hr",
	#define MAX_tags_restrict 46 /* ^^^ Text-scope tags ^^^ */
	"/a", "a",
	#define MAX_tags_hack 48
	"/font", "font"
};

/* Buffer for news pathname */
static char *newsleaf, newsfile[] = NEWS_ROOT "head.html\0\0\0\0\0\0\0\0\0\0\0\0";

/* Function declarations */
void docfoot(FILE* fp, struct period *perp, int fl);
int send_doc(int which);

/* Slot in macro to make fopen enforce unbufferedness */
/* #define my_fopen(x,y) fopen(x,y) */

/* Groupings of player existences */
#define GRP_LivePolice			(1)
#define GRP_DeadPolice			(2)
#define GRP_DeadWanted			(3)
#define GRP_DeadIncomp			(9)
#define GRP_LiveWanted			(4)
#define GRP_LiveIncomp			(5)
#define GRP_LiveCorrupt			(6)
#define GRP_LiveIncPolice		(7)
#define GRP_MaybeRedeemed		(8)
#define GRP_MAX					(10)

/* For categorisation and ordering of player "existences" */
int flgroup[16] =
{
	0,						/* comp   live unwanted player */
	GRP_LiveIncomp,			/* incomp live unwanted player (error) */
	GRP_LiveWanted,			/* comp   live wanted   player */
	GRP_LiveIncomp,			/* incomp live wanted   player */
	GRP_LivePolice,			/* comp   live unwanted police */
	GRP_LiveIncPolice,		/* incomp live unwanted police (error) */
	GRP_LiveCorrupt,		/* comp   live wanted   police */
	GRP_LiveIncPolice,		/* incomp live wanted   police */
	0,						/* comp   dead unwanted player */        
	GRP_DeadIncomp,			/* incomp dead unwanted player (error) */
	GRP_DeadWanted,			/* comp   dead wanted   player */        
	GRP_DeadIncomp,			/* incomp dead wanted   player */        
	GRP_DeadPolice,			/* comp   dead unwanted police */        
	GRP_DeadPolice,			/* incomp dead unwanted police (error) */
	GRP_DeadPolice,			/* comp   dead wanted   police */        
	GRP_DeadPolice			/* incomp dead wanted   police */
};

/* Heads of existence group lists */
pexist_p exgroups[GRP_MAX];

/* For casting away those consts */
typedef int (*sortexist__ftype)(const void* ex1p, const void* ex2p);

/***************************************************************************************************************************
** Substitute for, and check tags in, report and/or headline text. Output as HTML.                                        **
***************************************************************************************************************************/
struct freps__inpctx
{
	FILE *fin;
	long fin_left;
	char *pin;
	int held;
};

struct freps__outctx
{
	FILE *fout;
	char *pout, *pout_lim;
};

/* Basic input from strings or files and output to strings and/or files */
int cread(struct freps__inpctx* ctx)
{
	int c;

	if (ctx->held)
	{
		c = ctx->held;
		ctx->held = 0;
		return c;
	}
	else if (ctx->fin)
	{
		if (ctx->fin_left <= 0) return 0;
		else if ((c = getc(ctx->fin)) == EOF) return 0;
		else { --ctx->fin_left; return (c) ? (c) : '?'; }
	}
	else
	{
		if (c = *ctx->pin) ctx->pin++;
		return c;
	}	
}
void cunread(struct freps__inpctx* ctx, int c)
{
	ctx->held = c;
}
void cwritec(struct freps__outctx* ctx, int c)
{
	if (ctx->fout) fputc(c, ctx->fout);
	if (ctx->pout < ctx->pout_lim) *(ctx->pout++) = c;
}
void cwrites(struct freps__outctx* ctx, const char* p)
{
	int l, n;

	if (ctx->fout) fputs(p, ctx->fout);
	if ((n = ctx->pout_lim - ctx->pout) > 0)
	{
		if (n > (l = strlen(p))) n = l;
		memcpy(ctx->pout, p, n);
		ctx->pout += n;
	}
}
void cwritef(struct freps__outctx* ctx, const char *fmt, ...)
{
	int n;
	va_list ap;
	if (ctx->fout)
	{
		va_start(ap, fmt);
		vfprintf(ctx->fout, fmt, ap);
		va_end(ap);
	}
	if ((n = ctx->pout_lim - ctx->pout) > 0)
	{
		va_start(ap, fmt);
		ctx->pout += vsnprintf(ctx->pout, n, fmt, ap);
		va_end(ap);
	}
}
void cwritee(struct freps__outctx* ctx, char* p)
{
	int l, n;
	const char* q;
	if (ctx->fout) encapsulate(p, ctx->fout);
	while ((ctx->pout < ctx->pout_lim) && (n = *p++))
	{
		if (!(q = entity_table[n])) *(ctx->pout++) = n;
		else
		{
			if ((n = ctx->pout_lim - ctx->pout) > (l = strlen(q))) n = l;
			memcpy(ctx->pout, q, n);
			ctx->pout += n;
		}
	}
}

/* Parse mode change strings, optionally returning suffix */
subst_mode subst_parsemode(char* in, char** suffix, subst_mode inparm, char* p1, char* p2)
{
	int state = 2;
	subst_mode parm = inparm;
	char *p, *q;

	/* Clear suffix field */
	if (suffix) *suffix = 0;

	/* Debug: print string */
	IFDEB if (*in) fprintf(stderr, "%li    %s: %s: parse \"%s\"\n", uniqid, p1, p2, in);

	/* Check each char */
	for (p = in; (*p); p++)
	{
		/* '+' to set flags */
		if (*p == '+') state = 1;

		/* '-' to clear them */
		else if (*p == '-') state = 0;

		/* ':' to end switch strings and set suffix */
		else if ((*p == ':') || ((state == 2) && (suffix)))
		{
			/* Unexpected suffix */
			if (!suffix)
			{
				/* Complain */
				IFWARN fprintf(stderr, "%li !  %s: %s: Unexpected suffix: \"%s\"", uniqid, p1, p2, p + 1);

				/* Terminate early */
				break;
			}

			/* Point to suffix */
			else *suffix = p + ((*p == ':') ? 1 : 0);
		}

		/* The flag switches themselves */
		else
		{
			/* Switches must have been qualified beforehand */
			if (!(q = (state == 2) ? "Unqualified parm" : 0)) switch (*p)
			{
				case 'p':
				{
					parm = (parm & ~SUBST_Priv) | ((state) ? (SUBST_Priv) : 0);
					break;
				}
				case 'v':
				{
					if (!suffix) q = "No effect";
					else parm = (parm & ~SUBST_Verbatim) | ((state) ? (SUBST_Verbatim) : 0);
					break;
				}
				case 'e':
				{
					if (!suffix) q = "No effect";
					else parm = (parm & ~SUBST_Encapsulate) | ((state) ? (SUBST_Encapsulate) : 0);
					break;
				}
				case 'i':
				{
					if (!suffix) q = "No effect";
					else parm = (parm & ~SUBST_Introduce) | ((state) ? (SUBST_Introduce) : 0);
					break;
				}
				case 'd':
				{
					parm = (parm & ~SUBST_NoDirectives) | ((state) ? 0 : (SUBST_NoDirectives));
					break;
				}
				case 'f':
				{
					parm = (parm & ~SUBST_NoColourChange) | ((state) ? 0 : (SUBST_NoColourChange));
					break;
				}
				case 'n':
				{
					parm = (parm & ~SUBST_AllowNesting) | ((state) ? (SUBST_AllowNesting) : 0);
					break;
				}
				default: q = "Unrecognised parm";
			}

			/* Complaints */
			if (q) IFWARN fprintf(stderr, "%li !  %s: %s: %s: %i %c", uniqid, p1, p2, q, state, *p);
		}
	}

	/* Return new parms */
	return parm;
}

/* Process text by substituting for directives, checking allowed tags, etc. */
int subst(struct freps__inpctx *ctxinp, struct freps__outctx *ctxout, char* ident, struct appear ptab[], int nmax,
		  char* eref, timeval ewhen, subst_mode parm, report_p this_rptr, report_p rptrlist, char* ifont, char* title)
{
	int c, d, i, s, mt, n, lower, thingy, upper, linktag, rc = 0, inblock = 0;
	char *font = 0, *ofont, *p, cb[MAX_cb+2], *cbnum;
	struct appear savedptb;
	report_p rptr;


	/* Handy macro: used to open a new paragraph if not in one */
	#define startpara do { inblock = 1;\
						   if (font) cwritef(ctxout, "<p><font color=%s>", font);\
						   else cwrites(ctxout, "<p>");\
						 } while (0)

	/* Debug: print subst entry parameters */
	IFDEB fprintf(stderr, "{%s:%s:%lx:%p:%p}\n", eref, ident, parm, ctxinp->fin, ctxinp->pin);

	/* No character pushback yet */
	ctxinp->held = 0;

	/* Already included */
	if (this_rptr) this_rptr->flags |= RF_Already;

	/* Take input from given report */
	if (parm & SUBST_InputReps)
	{
		/* Paranoia */
		if (!this_rptr) erf(ERF_BadParms, 1);

		/* Report length */
		ctxinp->fin_left = this_rptr->length;

		/* Position reports file in appropriate place */
		if (fseek(ctxinp->fin = freps, this_rptr->fpos, SEEK_SET)) erf(ERF_fseekFailed, 2);
	}

	/* Setup report specific data */
	if ((this_rptr) && (parm & SUBST_Specifics))
	{
		pstate_p pstp = this_rptr->pptr->ext;
		appear_p aptbp = ((pstp) && (pstp->ext)) ? pstp->ext : 0;

		/* Preserve initial [0] entry */
		savedptb = ptab[0];
	
		/* Report specific values */
		ptab[0].pptr   = this_rptr->pptr;
		ptab[0].name   = this_rptr->pptr->name;
		ptab[0].pseud  = this_rptr->pseud;
		ptab[0].colour = (ifont) ? ifont : (this_rptr->flags & RF_Comment) ? COMCOL : 0;

		/* Fall back to defaults for reporting player */
		if (ptab[0].pstp = pstp)
		{
			if (!ptab[0].pseud) ptab[0].pseud = (aptbp) ? (aptbp->pseud) : 0;
			if (!ptab[0].colour && !(parm & SUBST_Main)) ptab[0].colour = (aptbp) ? (aptbp->colour) : 0;
		}

		/* Blatently vile colouration to highlight things that can't happen */
		if ((!ptab[0].colour) && !(parm & SUBST_Main)) ptab[0].colour = XXXCOL;

		/* Use player name if no pseudonym available */
		if (!ptab[0].pseud) ptab[0].pseud = ptab[0].name;
	}

	/* Don't use report specifics, but do use initial font, if any */
	else font = ifont;

	/* Take substitution flags from report flags */
	if ((this_rptr) && (parm & SUBST_RepFlags))
	{
		/* Clear SUBST_Priv and SUBST_AllowNesting if RF_Priv not set */
		if (!(this_rptr->flags & RF_Priv)) parm &= ~(SUBST_Priv|SUBST_AllowNesting);

		/* Clear SUBST_Introduce if RF_NoIntro set */
		if (this_rptr->flags & RF_NoIntro) parm &= ~SUBST_Introduce;

		/* Set SUBST_Verbatim if reproduction is RF_Verbatim */
		if ((this_rptr->flags & RF_Repro) == RF_Verbatim) parm |= SUBST_Verbatim;

		/* Set SUBST_Encapsulate if reproduction is RF_Encapsulate */
		if ((this_rptr->flags & RF_Repro) == RF_Encapsulate) parm |= SUBST_Encapsulate;

		IFDEB fprintf(stderr, "%li    %s: %s: subst_mode &%lx.\n", uniqid, eref, ident, parm);
	}

	/* Print brief introduction to report proper */
	if (parm & SUBST_Introduce)
	{
		c = ((this_rptr) && (this_rptr->pptr) && !(this_rptr->pptr->flags & PF_Special) && (mode & MODE_EvLink));
		if (!c) cwrites(ctxout, "<p>");
		else cwritef(ctxout, "<p><a href=\"" CGI_URL "plinfo.cgi?id=%s\">", this_rptr->pptr->id);
		if (font = ptab[0].colour) cwritef(ctxout, "<font color=%s>", font);
		cwritee(ctxout, ptab[0].pseud);
		if (font) cwrites(ctxout, "</font>");
		if (c) cwrites(ctxout, "</a>");
		cwritef(ctxout, " reports:</p>" LF );
		inblock = 0;
	}

	else if (parm & SUBST_HeadHack)
	{
		inblock = 1; /* Pretend to be in paragraph */
	}

	/* Print source verbatim */
	if (parm & SUBST_Verbatim) while (c = cread(ctxinp)) cwritec(ctxout, c);

	/* Encapsulate source */
	else if (parm & SUBST_Encapsulate)
	{
		startpara;
		while (c = cread(ctxinp))
		{
			if (!entity_table[c]) cwritec(ctxout, c);
			else cwrites(ctxout, entity_table[c]);
		}
	}

	/* Read source */
	else while (c = cread(ctxinp)) switch (c)
	{
		case '<':
		{
			/* Assemble tag name */
			for (cb[0] = c, i = 1; (i < MAX_cb) && (d = cread(ctxinp)) && (d != '>') && (d != ' '); )
			{
				/* Watch out for comments */
				if (((cb[i++] = d) == '-') && (i == 4) && (!strncasecmp(cb + 1, "!-", 2))) break;
			}

			/* Terminate it */
			cb[i] = '\0';

			/* Too long, or unclosed */
			if ((i >= MAX_cb) || (!d)) goto quotethetag;

			/* HTML comment */
			if (d == '-')
			{
				IFWARN fprintf(stderr, "%li: ! %s: %s: HTML comment." LF, uniqid, eref, ident);

				cwrites(ctxout, "<!--");
				for (s = 0; (c = cread(ctxinp)); cwritec(ctxout, c))
				{
					if ((c == '-') && (s < 2)) s++;
					else if ((c == '>') && (s == 2)) break;
					else s = 0;
				}
				cwrites(ctxout, "-->");
				continue;
			}

			/* Priv/unpriv tag array limit --- XXX ignored at the moment */
			mt = /*(parm & SUBST_RestrictTags) ? MAX_tags :*/ MAX_tags_hack /*_restrict*/;

			/* Is tag allowed? */
			for (n = 0; (n < mt); n++) if (!strcasecmp(tags[n], cb + 1)) break;

			/* Not recognised... quote it */
			if (n >= mt)
			{
				IFWARN fprintf(stderr, "%li: ! %s: %s: Illegal HTML tag: '%s%c'" LF, uniqid, eref, ident, cb, d);
quotethetag:	cb[i] = d; cb[i + 1] = '\0';
				if (!inblock) startpara;
				cwritee(ctxout, cb);
				if (d != '>')
				{
					s = 0; while ((c = cread(ctxinp)) && ((s & 1) || (c != '>')))
					{
						if (!entity_table[c]) cwritec(ctxout, c);
						else cwrites(ctxout, entity_table[c]);
						if (c == '"') s ^= 1;
					}
					if (!c) cwritef(ctxout, "%s>", (s) ? "\"" : "");
					else if (!entity_table[c]) cwritec(ctxout, c);
					else cwrites(ctxout, entity_table[c]);
				}
				continue;
			}

			/* Block-scope tag */
			if (n < MAX_tags_block)
			{
				/* Opening tag for new block -- close previous block */
				if (n & 1)
				{
					if (inblock) cwritef(ctxout, "%s<%s>" LF, ((font) ? "</font>" : ""), tags[inblock-1]);
				}
				/* Closing tag for current block -- close previous font tag */
				else if (n == inblock - 1)
				{
					if (font) cwritef(ctxout, "</font>");
				}	
				/* Ignore mismatched closing tags */
				else
				{
					IFWARN fprintf(stderr, "%li: ! %s: %s: Invalid block closure: '%s%c'\n", uniqid, eref, ident, cb, d);
					goto quotethetag;
				}
				inblock = 0;
			}
			/* Text-scope tag */
			else
			{
				if (!inblock) startpara;
			}

			cwrites(ctxout, cb);
			if (d != '>')
			{
				cwritec(ctxout, d);
				for (s = 0; (d = cread(ctxinp)) && ((s & 1) || (d != '>')); cwritec(ctxout, d))
				{
					if (d == '"') s ^= 1;
				}
			}
			if (!d) cwritef(ctxout, "%s>", (s) ? "\"" : "");
			else if (d == '>') cwritec(ctxout, d);

			/* Opened a new block */
			if ((n < MAX_tags_block) && (n & 1))
			{
				inblock = n; if (font) cwritef(ctxout, "<font color=%s>", font);
			}
			else if (n < MAX_tags_block) cwritec(ctxout, 10);

			continue;
		}

		case 10:
		case 13:
		{
			/* Double newline -> block break */
			if (((d = cread(ctxinp)) == 10) || (d == 13))
			{
				/* Plain break */
				if (inblock)
				{
					cwritef(ctxout, "%s<%s>" LF, ((font) ? "</font>" : ""), tags[inblock - 1]);
					if (font) cwritef(ctxout, "<%s><font color=%s>", tags[inblock], font);
					else cwritef(ctxout, "<%s>", tags[inblock]);
				}
				/* Ignore ones outside of blocks */
				continue;
			}

			/* Single, write through */
			else
			{
retry_d:		cunread(ctxinp, d);
write_c:		cwritec(ctxout, c);
				continue;
			}
		}

				/* Unread extra char */
retry_chk_d:	cunread(ctxinp, d);

		default:
		{
			/* If not in block, start paragraph at non-whitespace */
chk_qte_c:	if (!inblock)
			{
				if (((entity_table[c]) && !(*entity_table[c])) || (c == ' ') || (c == 9)) continue;
				startpara;
			}

			/* Write directly if not in need of quoting */
quote_c:	if (!entity_table[c]) cwritec(ctxout, c);

			/* Write quoted symbol strings */
			else cwrites(ctxout, entity_table[c]);

			continue;
		}

		case '[':
		{
			/* No directives allowed? */
			if (parm & SUBST_NoDirectives) goto chk_qte_c;

			/* Was it the last character, or "[[" sequence? Leave as '[' if so */
			if (!(d = cread(ctxinp)) || (d == '[')) goto chk_qte_c;

			/* Recognised directive? Write through if not */
			else if (((lower = (upper = (d < 'a')) ? d + 'a' - 'A' : d) < 'a') || (d > 'z')) goto retry_chk_d;

			/* Read entire directive string */
			for (cb[0] = d, i = 1; (i < MAX_cb) && (c = cread(ctxinp)) && (c != ']'); i++) cb[i] = c;

			/* Terminate it */
			cb[i] = '\0';

			/* Directive string too long? */
			if (i >= MAX_cb)
			{
bad_cmd:		IFWARN fprintf(stderr, "%li: ! %s: %s: Illegal directive: [", uniqid, eref, ident);
				IFWARN for (p = cb; (*p); p++) fputc(((*p < 32) ? '?' : *p), stderr);
				IFWARN fputs("]" LF, stderr);
quote_cmd:		if (!inblock) startpara;
				cwritec(ctxout, '[');
				cwritee(ctxout, cb);
				cwritec(ctxout, ']');
				continue;
			}

			/* Non-numeric directive parameters */
			switch (lower)
			{
				/****** Anchor insertion directive ******/
				case 'a':
				{
					goto bad_cmd;

					/* switch (cb[1])
					** {
					** 	case 'w': p = "<a href=\"wanted.html\">"; break;
					** 	case 'p': p = "<a href=\"../police.html\">"; break;
					** 	case 'i': p = "<a href=\"incomp.html\">"; break;
					** 	case 'h': p = "<a href=\"head.html\">"; break;
					** 	case 'u': p = "<a href=\"hups.html\">"; break;
					** 	default : p = "</a>";
					** }
					*/

write_p:			cwrites(ctxout, p);
					continue;
				}

                /****** Report nesting directive ******/
				case 'z':
				{
					long fpos;
					subst_mode nparm;
					
					/* Tag has notional block scope */
    				if (inblock) goto quote_cmd;
	 
					/* Check privs */
					if (!(parm & SUBST_AllowNesting)) goto bad_cmd;

					/* Restrict inherited parameters by default */
					nparm = (parm & ~(SUBST_AllowNesting|SUBST_Priv|SUBST_Main))
						  | (SUBST_Specifics|SUBST_InputReps|SUBST_Introduce|SUBST_RepFlags);
					
					/* Don't parse parameter if unpriv'd */
					if (!(parm & SUBST_Priv)) p = cb + 1;

					/* Parse for mode change switches, and suffix */
					else nparm = subst_parsemode(cb + 1, &p, nparm, eref, ident);

					/* Don't yet allow identified reports */
					if ((p) && (*p)) goto bad_cmd;

					/* Preserve our own input file context */
					if ((ctxinp->fin == freps) && (-1L == (fpos = ftell(freps)))) erf(ERF_ftellFailed, 30);

					/* Run through all as yet unseen reports */
					for (rptr = rptrlist, n = 0; (rptr); rptr = rptr->link_sub)
					{
						/* Reports must not already have ben seen, and not be hidden */
						if (!(rptr->flags & (RF_Already|RF_Hidden)))
						{
							/* Input context for nested calls */
							struct freps__inpctx ctxnew = { 0, 0, 0, 0 };
                    	
							/* Perform the substitution */
							if (rc = subst(&ctxnew, ctxout, rptr->rid, ptab, 3, eref, ewhen,
									 nparm, rptr, rptrlist, (upper) ? 0 : (font), title)) erf(rc, 33);
                    	
							/* One more done */
							++n;
						}
					}

					/* Re-establish our own input file context */
					if ((n) && (ctxinp->fin == freps) && (fseek(freps, fpos, SEEK_SET))) erf(ERF_fseekFailed, 34);

					/* Done */
					continue;
				}

				/****** Title directive  ******/
				case 't':
				{
                    if ((!title) || !(parm & SUBST_Priv)) goto bad_cmd;
					if (!inblock) startpara;
					cwrites(ctxout, title);
					continue;
				}

				/****** parm change ******/
				case 'm':
				{
					if (!(parm & SUBST_Priv)) goto bad_cmd;
					parm = subst_parsemode(cb + 1, 0, parm, eref, ident);
					continue;
				}

				/****** Insert more directives here ******/
			}

			/* Extra parameter */
			cbnum = cb + ((thingy = ((cb[1] == 'l') || (cb[1] == 'L'))) ? 2 : 1);

			/* No parameter */
			if (!cbnum[0]) n = -1;

			/* Convert numerical parameter */
			else if ((n = (int)strtol(cbnum, 0, 10)) < 0) goto bad_cmd;

			/* Numeric directives with nonstandard parameter */
			switch (lower)
			{
				/****** Time and date ******/ 
				case 'd':
				{
					if (!inblock) startpara;
					if (n <= 0) cwritef(ctxout, ""TDISP"%s", Thm(ewhen), (T_h(ewhen) < 12) ? "am" : "pm");
					else if (n == 1) cwritef(ctxout, TSING, T_h(ewhen));
					else if (n == 2) cwritef(ctxout, TSING, T_m(ewhen));
					else if (n == 3) cwrites(ctxout, (T_h(ewhen) < 12) ? "am" : "pm");
					else goto bad_cmd;
					continue;
				}

				/****** Some font colour changes ******/
				/* case 'f':
				** {
				** 	if (n > 0) break;
				** 	if ((!inblock) || (!font)) goto quote_cmd;
				** 	cwrites(ctxout, "</font>");
				** 	font = 0;
				** 	continue;
				** }*/

				/****** Manual font colour changes ******/
				/* case 'c':
				** {
				** 	fprintf(stderr, "(%d,%d)", n, MAX_COLS);
				** 	if ((n > MAX_COLS) || ((n > 0) && !(p = typecoltab[n - 1]))) goto bad_cmd;
				** 	else if (n <= 0) p = 0;
				** 	if ((!font) || (!p) || (strcmp(font, p)))
				** 	{
				** 		if (font) cwrites(ctxout, "</font>");
				** 		if (p) cwritef(ctxout, "<font color=%s>", p);
				** 	}
				** 	font = p;
				** 	continue;
				** }*/

				/****** Insert more directives here ******/
			}

			/* Standard numerical parameter out of range? */
			if ((n < -1) || ((lower != 'f') && (n == -1)) || (n >= nmax)) goto bad_cmd;

			/* Permanent font changes allowed? */
			if ((lower == 'f') && (parm & SUBST_NoColourChange)) goto quote_cmd;

			/* 'f' may be used outside block-scope, but results in no data being written */
			if ((!inblock) && (lower == 'f')) 
			{
				font = (n == -1) ? 0 : ptab[n].colour;
				continue;
			}

			/* Otherwise, must be inside a block */
			else if (!inblock) startpara;

			/* Temporary (or permanent) change in font colour */
			if ((upper) || (lower == 'f'))
			{
				p = (n == -1) ? 0 : ptab[n].colour;
				if ((ofont = font) && (p) && (!strcmp(font, p))) ofont = p;
				else if (ofont) cwrites(ctxout, "</font>");
				if ((font = p) && (font != ofont)) cwritef(ctxout, "<font color=%s>", p);
			}
			else ofont = font;

			/* Numeric directives with standard parameter */
			switch (lower)
			{
				case 'f': continue;

				/****** Insert pseudonym ******/
				case 'p': case 'q':
				{
					if (!(p = ptab[n].pseud)) goto bad_cmd;
					if (((lower == 'q') || (thingy)) && (ptab[n].pptr))
					{
						cwritef(ctxout, "<a href=\""CGI_URL"plinfo.cgi?id=%s\">", ptab[n].pptr->id);
						if (font) cwritef(ctxout, "<font color=%s>", font);
						cwritee(ctxout, p);
						if (font) cwrites(ctxout, "</font>");
						cwrites(ctxout, "</a>");
					}
					else cwritee(ctxout, p);
					break;
				}

				/****** Insert name ******/
				case 'n':
				{
					if (!(p = ptab[n].name)) goto bad_cmd;
					if ((thingy) && (ptab[n].pptr))
					{
						cwritef(ctxout, "<a href=\""CGI_URL"plinfo.cgi?id=%s\">", ptab[n].pptr->id);
						if (font) cwritef(ctxout, "<font color=%s>", font);
						cwritee(ctxout, p);
						if (font) cwrites(ctxout, "</font>");
						cwrites(ctxout, "</a>");
					}
					else cwritee(ctxout, p);
					break;
				}

				/****** List all pseudonyms ******/
				case 'l':
				{
					ppseud_p pseudp;
					char fb[96];
					if ((!ptab[n].pptr) || (!ptab[n].pptr->ext)) goto bad_cmd;
				 	if ((!upper) || (!font) || ((ofont) && (streq(ofont, font)))) p = ", ";
				 	else if (!ofont) snprintf(p = fb, 96, "</font> AKA <font color=\"%s\">", font);
					else snprintf(p = fb, 96, "</font><font color=\"%s\"> AKA </font><font color=\"%s\">", ofont, font);
                    for (pseudp = ptab[n].pptr->ext->exist->pseuds; (pseudp); pseudp = pseudp->link_ex)
					{
						cwritee(ctxout, pseudp->text);
						if (pseudp->link_ex) cwrites(ctxout, p);
					}
					break;
				}

				/****** Insert more directives here ******/
				default: goto bad_cmd;
			}

			/* Undo temporary change in font colour */
			if ((upper) && (ofont != font))
			{
				if (font) cwrites(ctxout, "</font>");
				if (ofont) cwritef(ctxout, "<font color=%s>", ofont);
				font = ofont;
			}
			continue;
		}
	}

	/* Close open block-scope tags */
	if ((inblock) && !(parm & SUBST_HeadHack)) cwritef(ctxout, "%s<%s>" LF, ((font) ? "</font>" : ""), tags[inblock-1]);

	/* Restore initial element */
	if ((this_rptr) && (parm & SUBST_Specifics)) ptab[0] = savedptb;

	/* Terminate string output */
	if (ctxout->pout) *(ctxout->pout) = '\0';

	/* Some of the report remains? */
	if ((ctxinp->fin) && (ctxinp->fin_left > 0))
	{
		/* Issue warning */
		IFWARN fprintf(stderr, LF "%li: ! %s truncated by %li." LF, uniqid, ident, ctxinp->fin_left);
	}

	/* End of handy macro */
	#undef startpara


_erf: /***** Handle errors *****/

	/* Debug */
	if (rc) fprintf(stderr, "%li !! subst(%i):%i [%s]\n", uniqid, ERF_CONTEXT(rc), ERF_TYPE(rc), ident);

	/* Only retain low bits of normal rc's */
	return (ERF_LOWBITS(rc));
}

/* Process a top-level report into HTML; store in file */
int printrep(FILE* fp, report_p m_rptr, report_p rptrs, struct appear ptab[], int nmax, event_p ep, int how, char* title)
{
	struct freps__inpctx ctxinp = { 0, 0, 0, 0 };
	struct freps__outctx ctxout = { 0, 0, 0 };
	subst_mode parm;
	char *p;

	/* Output file */
	ctxout.fout = fp;

	/* Take input from main report text */
	if (m_rptr)
	{
		parm = SUBST_Main|SUBST_InputReps|SUBST_Specifics|SUBST_AllowNesting|SUBST_RepFlags|SUBST_Priv;
		p = m_rptr->rid;

		/* Hack --- set RF_Priv if RF_Main set --- backwards compatibility --- XXX */
		if (m_rptr->flags & RF_Main) m_rptr->flags |= RF_Priv;
	}

	/* Use default main report text for assassinations */
	else if (ep->flags & EF_Assassination)
	{
		ctxinp.pin = (ep->flags & EF_Kill) ? FRAG_DEFAULT_MAIN_KILLREP : FRAG_DEFAULT_MAIN_ASSREP;
		p = "(default_main_ass)";
		parm = SUBST_Main|SUBST_AllowNesting|SUBST_Priv;
	}

	/* Use other default main report text */
	else
	{
		ctxinp.pin = FRAG_DEFAULT_MAIN_REPORT;
		p = "(default_main)";
		parm = SUBST_Main|SUBST_AllowNesting|SUBST_Priv;
	}

	/* Perform the substitution */
	return subst(&ctxinp, &ctxout, p, ptab, nmax, ep->ref, ep->when, parm, m_rptr, rptrs, 0, title);
}

/* Process a headline into HTML; store in file and/or buffer */
int printhead(FILE* fp, char* str, char* to, char* lim, char* c1, char* c2, char* eref, timeval ewhen,
			   pstate_p p1sp, pstate_p p2sp, char* title)
{
	struct freps__inpctx ctxinp = { 0, 0, 0, 0 };
	struct freps__outctx ctxout = { 0, 0, 0 };
	struct appear ptab[3] = { { 0, 0, 0, 0, 0 }, { 0, 0, 0, 0, 0 }, { 0, 0, 0, 0, 0 } };

	if (ptab[1].pstp = p1sp) ptab[1].pptr = p1sp->plp;
	if (ptab[2].pstp = p2sp) ptab[2].pptr = p2sp->plp;

	ptab[1].colour = c1;
	ptab[2].colour = c2;

	ptab[1].pseud = (p1sp) ? p1sp->cps : 0;
	ptab[2].pseud = (p2sp) ? p2sp->cps : 0;

	ptab[1].name = (p1sp && p1sp->plp) ? p1sp->plp->name : 0;
	ptab[2].name = (p2sp && p2sp->plp) ? p2sp->plp->name : 0;

	ctxinp.pin = str;
	ctxout.fout = fp;
	ctxout.pout = to;
	ctxout.pout_lim = lim;

	/* Perform the substitution */
	return subst(&ctxinp, &ctxout, "headline", ptab, 3, eref, ewhen, SUBST_HeadHack|SUBST_Priv, 0, 0, 0, title);
}

/***************************************************************************************************************************
** Function hooks to load players and build events table and write headline or news entries.                              **
***************************************************************************************************************************/
struct news_context
{
	struct period *perp, *lastperp, *thisperp;
	FILE *fhead, *fnews;
	int day, repcnt, missingreps;
	report_p first_rptr, last_rptr, main_rptr;
	struct headln *headp, *prevheadp;
	timeval uptim;
	char* title;
};

/* uread() function hook: get full player information for all players */
int news_uread_func(player_p pptr, int state, void* ctx)
{
	/* Link into list */
	pptr->link = plist;
	plist = pptr;

	/* All players, please */
	return (1+8+16);
}

/* evread() function hook: process report ids for event */
int news_report_hook(event_p ep, char* rid, int state, void* context, evolve__ctx_t* evolvectx)
{
	struct news_context* ctx = context;
	report_p rptr;

	/* Lookup report information */
	for (rptr = replist; (rptr); rptr = rptr->link_all) if (!strcmp(rptr->rid, rid)) break;

	/* Matched */
	if (rptr)
	{
		/*fprintf(stderr, "=\"%s\"", rptr->rid);*/

		/* Link up as first report for this event */
		if (!ctx->first_rptr) ctx->first_rptr = rptr;

		/* Link to from previous report in chain */
		if (ctx->last_rptr) ctx->last_rptr->link_sub = rptr;

		/* Last report in chain for this event */
		ctx->last_rptr = rptr;

		/* None past this report yet */
		rptr->link_sub = 0;

		/* Clear "already processed" flag */
		rptr->flags &= ~(RF_Already);

		/* Note first "main" report */
		if ((!ctx->main_rptr) && (rptr->flags & RF_Main)) ctx->main_rptr = rptr;

		/* Count them */
		++ctx->repcnt;

		/* Report was timestamped at last update? Note most recent such timestamp */
		if (rptr->uptim > ctx->uptim) ctx->uptim = rptr->uptim;
	}

	/* Report is missing */
	else
	{
		IFWARN fprintf(stderr, "%li: ! repevhook: missing report \"%s\", #%d for event \"%s\"\n",
					   uniqid, rid, ++ctx->missingreps, ep->ref);
	}

	/* Next */
	return 0;
}

/* evread() function hook: deal with news reports once all rids known */
int news_second_hook(event_p ep, pstate_p p1s, pstate_p p2s, int pg1, int pg2, void* context, evolve__ctx_t* evolvectx)
{
	struct news_context* ctx = context;
	report_p rptr;
	player_p p1ptr = 0, p2ptr = 0;
	pstate_p psp;
	appear_p ptab;
	int i, rc = 0, pmax;
	char** p;

	/* No report ids found? Silently drop */
	if (!ctx->first_rptr) return 0;
	
	/*fprintf(stderr, "%li:  ref=\"%s\" %d reports %d missing main %p first %p\n",
			uniqid, ep->ref, ctx->repcnt, ctx->missingreps, ctx->main_rptr, ctx->first_rptr);*/

	/* Adjust event update time in headlines according to report update times */
	if ((mode & MODE_Accurate) && (ctx->headp) && (ctx->uptim > ctx->headp->time))
	{
		struct headln *hq, *hr;

		IFWARN fprintf(stderr, "%li: ! %s: report ("TDEBfmt") newer than event update ("TDEBfmt").\n", uniqid,
					ep->ref, TDEBparm(ctx->uptim), TDEBparm(ep->when));
								 
		/* Remove from old position in chain */
		if (ctx->prevheadp) ctx->prevheadp->link = ctx->headp->link;

		/* Or remove from old head of chain */
		else headbase = ctx->headp->link;

		/* Store last date of report alteration */
		ctx->headp->time = ctx->uptim;

		/* Find new position in chain */
		for (hr = 0, hq = headbase; (hq) && (hq->time >= ctx->uptim); hq = hq->link) hr = hq;
		
		/* Link into chain */
		if (hr) { ctx->headp->link = hr->link; hr->link = ctx->headp; }
		
		/* Link at head of list */
		else { ctx->headp->link = headbase; headbase = ctx->headp; }		
	}

	/* No need to continue if not printing news reports */
	if (!(ep->flags & EF_News)) return 0;

	/* Missing main report? */
	IFWARN if (!ctx->main_rptr) fprintf(stderr, "%li: ! No main report: ref=\"%s\" %d reports %d missing: using default\n",
										uniqid, ep->ref, ctx->repcnt, ctx->missingreps);

	/* Allocate reference table (repcnt+2 is an upper bound on the number of players involved) */
	if (!(ptab = malloc((3 + ctx->repcnt) * sizeof(struct appear)))) erf(ERF_mallocFailed, 2);

	/* Main player pointer */
	if ((p1s) && (p1ptr = p1s->plp)) p1s->ext = &ptab[1];

	/* Paranoia: complain about missing pointers */
	else erf(ERF_MissingPid, 3);

	/* Victim may not be present */
	if (p2s)
	{
		if (!(p2ptr = p2s->plp)) erf(ERF_MissingPid, 5);
		p2s->ext = &ptab[2];
	}

	/* Paranoia */
	else if (ep->flags & EF_Assassination) erf(ERF_InternalError, 4);

	/* Entry zero currently meaningless (allocated to each report individually) */
	ptab[0].pstp = 0;
	ptab[0].pptr = 0;
	ptab[0].name = 0;
	ptab[0].pseud = 0;
	ptab[0].colour = 0;

	/* Assassin's entry */
	ptab[1].pstp = p1s;
	ptab[1].pptr = p1ptr;
	ptab[1].name = p1ptr->name;
	ptab[1].pseud = (p1s->cps) ? (p1s->cps) : "*** unknown ***";
	ptab[1].colour = typecoltab[pg1];
	                 
	/* Target */
	ptab[2].pstp = p2s;
	ptab[2].pptr = p2ptr;
	ptab[2].name = (p2ptr) ? p2ptr->name : "*** unknown ***";
	ptab[2].pseud = ((p2s) && (p2s->cps)) ? (p2s->cps) : "*** unknown ***";
	ptab[2].colour = typecoltab[pg2+(SCDEF_MAX_Cols * ((ep->flags & EF_Kill) ? 2 : 1))];

	/* Look for each player with a report */
	for (pmax = 3, p = witcoltab, rptr = ctx->first_rptr; (rptr); rptr = rptr->link_sub)
	{
		/* Clear "already seen" flag */
		rptr->flags &= ~(RF_Already);

		/* Give each distinct player one entry */
		for (i = 1; (i < pmax); i++) if ((ptab[i].pptr) && (ptab[i].pptr == rptr->pptr)) break;

		/* Already seen */
		if (i < pmax)
		{
			/* May need to allocate colours from witness pool after all */
			if (!ptab[i].colour) ptab[i].colour = (*p) ? *(p++) : *(p = witcoltab);

			continue;
		}

		/*fprintf(stderr, "+%d/%d\"%s\"for\"%s\"", i, pmax, rptr->rid, rptr->pptr->id);*/

		/* Outfit table */
		ptab[pmax].pstp = psp = rptr->pptr->ext;
		ptab[pmax].pptr = rptr->pptr;
		ptab[pmax].name = rptr->pptr->name;
		ptab[pmax].pseud = ((psp) && (psp->exist->dps)) ? (psp->exist->dps->text) : "*** unknown ***";

		/* Umpire gets his own colour */
		if ((rptr->pptr) && (!strcmp(rptr->pptr->id, UMP_ID))) ptab[pmax].colour = UMPCOL;

		/* Hack to prevent allocation of colours to owners of auto-generated main reports */
		else if ((rptr->flags & RF_AutoGen) && (rptr->flags & RF_Main)) ptab[pmax].colour = 0;

		/* Otherwise allocate colours from witness pool */
		else ptab[pmax].colour = (*p) ? *(p++) : *(p = witcoltab);

		/* Setup pointer */
		if (psp) psp->ext = &ptab[pmax];

		/* Increment count of players with reports */
		pmax++;
	}

	/* Write editing details */
	if (mode & MODE_Priv) fprintf(ctx->fnews, "\n\n<p><a name=\"%s\"></a><a href=\"" CGI_URL "event.cgi?ev_ref=%s\">"
								  "Edit event details</a></p>", ep->ref, ep->ref);

	/* Write link details */
	else fprintf(ctx->fnews, "\n\n<p><a name=\"%s\"></a></p>" LF, ep->ref);

	/* Write main report body */
	rc = printrep(ctx->fnews, ctx->main_rptr, ctx->first_rptr, ptab, pmax, ep, 0, ctx->title);

	/* Write link details */
	if ((mode & MODE_EvLink) && (ep->flags & EF_Open))
	{
		fprintf(ctx->fnews, "\n<p align=right>[<a href=\"" CGI_URL "event.cgi?ev_ref=%s\">"
							"Add/edit reports</a>]</p>" LF LF, ep->ref);
	}


_erf: /***** Handle errors *****/

	/* Debug */
	if (rc) fprintf(stderr, "%li !!  evhook(%i):%i on \"%s\"\n", uniqid, ERF_CONTEXT(rc), ERF_TYPE(rc), ep->ref);

	/* Only retain low bits of normal rc's */
	return (-ERF_LOWBITS(rc));
}

/* evread() function hook: deal with news events */
int news_evolve_hook(event_p ep, pstate_p p1s, pstate_p p2s, int pg1, int pg2, void* context, evolve__ctx_t* evolvectx)
{
	player_p p1ptr = 0, p2ptr = 0;
	struct news_context* ctx = context;
	int rc = 0;
	char *p, *q, *c1p, *c2p;

	/* Don't print invisible events (already know that EF_News set and EF_Ignore clear) */
	if (ep->flags & EF_Invisible) return 0;
	
	/* Not presenting news or headlines? */
	if (!(mode & (MODE_NEWS|MODE_HEAD|MODE_CHANGES|MODE_FRAGMENT))) return 0;
	
	/* fprintf(stderr, "%li:   evhook[%s]\n", uniqid, ep->ref); */

	/* Ensure we only report news from the relevent period - could finish early if possible? XXX */
	if ((ctx->perp != (ctx->thisperp = per(ep->when))) && (ctx->perp)) return 0;
	
	/* Have crossed period boundary */
	if (ctx->lastperp != ctx->thisperp)
	{
		/* Complete previous period documents */
		if ((ctx->lastperp) && (mode & MODE_NewsToFiles))
		{
			/* Finish old news HTML document */
			docfoot(ctx->fnews, ctx->lastperp, 0); /* erf(3) */
	
			/* Close old news */
			if (!fclose(ctx->fnews)) ctx->fnews = 0; else erf(ERF_fcloseFailed, 4);
		}
	
		/* Open new headline section */
		/* if (ctx->fhead) fprintf(ctx->fhead, "</p><h3><hr>%s<hr></h3><p>" LF, 
		ctx->thisperp->title); */
	
		/* News output to stdout? */
		if (mode & MODE_NewsOnStdout)
		{
			/* Print news section title if in all-in-one mode */
			if (!ctx->perp) fprintf(ctx->fnews, LF "<h2><hr>%s<hr></h2>" LF, ctx->thisperp->title);
		}
	
		/* Prepare the new news file */
		else if (mode & MODE_NewsToFiles)
		{
			/* Build new filename */
			if (10 > sprintf(newsleaf, "news%s.html", ctx->thisperp->index)) erf(ERF_printfFailed, 6);
	
			/* Create and open the new file */
			if (!(ctx->fnews = fopen(newsfile, "wb"))) erf(ERF_fopenNews, 7);
	
			/* News header */
			if (fprintf(ctx->fnews, LF "<HTML><HEAD><TITLE>" GAME " Game News - %s</TITLE></HEAD>"
									LF "<BODY " COLSCHEME ">" LF "<h1><hr>" GAME " Game News - %s<hr></h1>" LF,
									ctx->thisperp->title, ctx->thisperp->title) < 0) erf(ERF_printfFailed, 8);
		}
	
		/* Enforce new period */
		ctx->lastperp = ctx->thisperp;
	
		/* Ensure dayname is rewritten when necessary */
		if (ctx->day == T_d(ep->when)) ctx->day = -2;
	}
	
	/* Write news to fnews */
	if ((mode & MODE_NEWS) && (!ctx->fnews)) erf(ERF_InternalError, 9);
	
	/* Date has changed */		
	if (ctx->day != T_d(ep->when))
	{
		/* Report the name of the new day in news */
		if (mode & MODE_NEWS) fprintf(ctx->fnews, "<h3>%s</h3>" LF, fdayname(T_d(ep->when), 0));
	
		/* New dayname in headline HTML */
		if ((ctx->fhead) && (ctx->day != -2)) fprintf(ctx->fhead, "</p><h3>%s</h3><p>" LF, fdayname(T_d(ep->when), 0));
	
		/* Remember this new day */
		ctx->day = T_d(ep->when);
	}

	/*if (ctx->fnews) fprintf(ctx->fnews, LF "news(%s|%lx)" LF, ep->ref, ep->flags);*/
	/*if (ctx->fhead) fprintf(ctx->fhead, LF "head(%s|%lx)" LF, ep->ref, ep->flags);*/

	/* Check player 1 information */
	if ((!p1s) || !(p1ptr = p1s->plp))
	{
		IFWARN fprintf(stderr, "%li: ! evhook[%s] unknown pl1 \"%s\"\n", uniqid, ep->ref, (p1s ? p1s->pid : ""));
		erf(0, 0);
	}

	/* Check player 2 information */
	if ((p2s) && !(p2ptr = p2s->plp))
	{
		IFWARN fprintf(stderr, "%li: ! evhook[%s] unknown pl2 \"%s\"\n", uniqid, ep->ref, p2s->pid);
		erf(0, 0);
	}

	/* Player colouration */
	c1p = typecoltab[pg1];
	c2p = typecoltab[pg2+(SCDEF_MAX_Cols * ((ep->flags & EF_Kill) ? 2 : 1))];

	/* Title (based on outcome of event) */
	if (!(ep->flags & EF_Assassination)) ctx->title = 0;

	/* Check players' status */
	else ctx->title = titletab[((ep->flags & EF_Kill) ? 1 : 0) 
							   + ((p2s->pflags & PF_Dead) ? 2 : 0)
							   + ((p1s->pflags & PF_Dead) ? 4 : 0)];

	/* No stored headline as yet */
	ctx->headp = 0;

	/* Time of last update to event information */
	ctx->uptim = ep->news_date;

	/* Store headlines if EF_News and EF_Headline both set */
	if (!((~ep->flags) & (EF_ShowHeadline|EF_News)) && ((mode & MODE_CHANGES) || (ctx->fhead)))
	{
		/* Retain headline? Point to buffer if needed */
		p = (mode & MODE_CHANGES) ? (hbuf) : (0);

		/* Write start of headline into headlines file */
		if (ctx->fhead) fprintf(ctx->fhead, "<a href=\"news%s.html#%s\">["TDISP"%s]</a> ", perid(ep->when),
								ep->ref, Thm(ep->when), ((T_h(ep->when) < 12) ? "am" : "pm"));

		/* Write link to event editor into headlines file */
		if ((ctx->fhead) && (mode & MODE_EvLink))
		{
			fprintf(ctx->fhead, "[<a href=\"" CGI_URL "event.cgi?ev_ref=%s\">Report</a>] ", ep->ref);
		}

		/* Write (and build in buffer) the headline proper */
		if (rc = printhead(ctx->fhead, ep->news_head, p, ((p) ? (p + MAX_hbuf) : p),
						   c1p, c2p, ep->ref, ep->when, p1s, p2s, ctx->title)) erf(rc, 14);
	
		/* Save headline for later */
		if (p)
		{
			struct headln *hq, *hr, *hp;

			/* Store strings */
			if (!(p = malloc(1 + strlen(ep->ref))) || !(q = malloc(1 + strlen(hbuf)))) erf(ERF_mallocFailed, 15);
	
			/* Space for headline structure */
			if (!(ctx->headp = hp = malloc(sizeof(struct headln)))) erf(ERF_mallocFailed, 16);
	
			/* Store text */
			strcpy((hp->eref = p), ep->ref);
			strcpy((hp->head = q), hbuf);
	
			/* Store time of event */
			hp->etim = ep->when;
		
			/* Store last date of event alteration */
			hp->time = ctx->uptim;
		
			/* Sort into chain */
			for (hr = 0, hq = headbase; (hq) && (hq->time >= hp->time); hq = hq->link) hr = hq;
		
			/* Link into chain */
			if (ctx->prevheadp = hr) { hp->link = hr->link; hr->link = hp; }
		
			/* Link at head of list */
			else { hp->link = headbase; headbase = hp; }
		}

		/* End headline */
		if ((ctx->fhead) && (EOF == fputs("<br>" LF, ctx->fhead))) erf(ERF_fputsFailed, 17);
	}

	/*fprintf(stderr, "blah %s %i\n", ep->ref, (mode & MODE_NEWS) ? 1 : 0);*/

	/* No reports associated with this event yet */
	ctx->first_rptr = ctx->last_rptr = ctx->main_rptr = 0;
	ctx->missingreps = ctx->repcnt = 0;

	/* Need to write news entry, or check report update times? Finished if not */
	evolvectx->repfunc = ((mode & MODE_NEWS) || (ctx->headp && (mode & MODE_Accurate))) ? news_report_hook : 0;
	evolvectx->secfunc = ((mode & MODE_NEWS) || (ctx->headp && (mode & MODE_Accurate))) ? news_second_hook : 0;

	/* Continue (via hooks) */
	return 0;


_erf: /***** Handle errors *****/

	/* Debug */
	if (rc) fprintf(stderr, "%li !! evhook(%i):%i on \"%s\"\n", uniqid, ERF_CONTEXT(rc), ERF_TYPE(rc), ep->ref);

	/* Only retain low bits of normal rc's */
	return (ERF_LOWBITS(rc));
}

/***************************************************************************************************************************
** Autogenerate the news update log                                                                                       **
***************************************************************************************************************************/
int writeheadch(struct period* lastperp)
{
	struct headln* hp;
	FILE* fp = stdout;
	int day;

#ifndef http

	/* Build new filename */
	sprintf(newsleaf, "hups.html");

	/* Create and open the new file */
	if (!(fp = fopen(newsfile, "wb"))) return (ERF_fopenNews);

#endif

	/* Headline HTML header */
	fputs(FRAG_UPDATES_HTML_HEADER, fp);

	/* Print each headline */
	for (day = -1, hp = headbase; (hp); hp = hp->link)
	{
		/* Date has changed */		
		if (day != T_d(hp->time))
		{
			/* New dayname in headline HTML */
			fprintf(fp, "</p><h3>New on %s:</h3><p>" LF, fdayname(T_d(hp->time), 0));
	
			/* Remember this new day */
			day = T_d(hp->time);
		}

		if (mode & MODE_EvLink) fprintf(fp, "[<a href=\"" CGI_URL "event.cgi?ev_ref=%s\">Report</a>] ", hp->eref);

		/* Print headline */
		fprintf(fp, "<a href=\"news%s.html#%s\">[%s "TDISP"]</a> %s<br>" LF, perid(hp->etim),
					hp->eref, fdayname(T_d(hp->etim), "%d %b"), Thm(hp->etim), hp->head);
	}

	/* Headline HTML footer */
	fputs(FRAG_UPDATES_HTML_FOOTER, fp);

	/* Finish headline HTML document */
	docfoot(fp, lastperp, 6);

#ifndef http

	/* Close file */
	fclose(fp);

#endif

	/* Debug output */
	fprintf(stderr, "%li:   Updates written.\n", uniqid);

	return 0;
}

/***************************************************************************************************************************
** Autogenerate the various lists                                                                                         **
***************************************************************************************************************************/
int writepolice(struct period* lastperp)
{
	pexist_p exp, *expp;
	player_p pptr;
	FILE* fp = stdout;
	int i, colour = 0, z;
	char *p, *q;

#ifndef http

	/* Build new filename */
	sprintf(newsleaf, "police.html");

	/* Create and open the new file */
	if (!(fp = fopen(newsfile, "wb"))) return ERF_fopenNews;

#endif

	/* HTML header */
	fputs(FRAG_POLICE_HTML_HEADER, fp);

	/* Run through live unwanted police */
	for (z = 0, exp = exgroups[GRP_LivePolice]; (exp); exp = exp->link_all)
	{
		/* Don't show hidden players */
		if ((pptr = exp->psp->plp)->flags & PF_Hidden) continue;
		p = (colour = 1 - colour) ? "#bbbbee" : "#ddddff";
		if (!z++) fputs(LF "<p><table cols=6 cellspacing=4 cellpadding=4 border=1>"
						LF "<thead><td>Rank:</td><td>Title:</td><td>Name:</td>"
						LF "<td>College:</td><td>Address:</td><td>Comments:</td></thead>", fp);
		fprintf(fp, LF "<tr><td bgcolor=%s><font color="FCOL">%s</font></td>"
					LF "<td bgcolor=%s><font color="FCOL">", p, rank_name[LIM_RANK(exp->rank)], p);
		if (exp->dps) encapsulate(exp->dps->text, fp);
		fprintf(fp, "</font></td><td bgcolor=%s><font color="FCOL">%s", p, pptr->name);
		if (pptr->flags & PF_Mailable) fprintf(fp, " [<a href=\"mailto:%s\">e-mail</a>]", pptr->email);
		fprintf(fp, "</font></td>" LF "<td bgcolor=%s><font color="FCOL">%s</font></td>"
				LF "<td bgcolor=%s><font color="FCOL">%s</font></td>", p, pptr->coll, p, pptr->addr);
		if (!(pptr->flags & PF_LongComment))
		{
			fprintf(fp, "<td bgcolor=%s><font color="FCOL">%s</font></td></tr>", p, pptr->mafia);
		}
		else fprintf(fp, "<td></td></tr><tr><td colspan=6 bgcolor=%s><font color="FCOL">%s</font></td></tr>",
					 p, pptr->mafia);
	}

	if (!z) fputs(LF "<!--#include file=\"" FRAG_URL "npol2none.txt\" -->", fp);
	else fputs(LF "</table></p><!--#include file=\"" FRAG_URL "npol2.txt\" -->", fp);

	/* Run through live corrupt police */
	for (z = 0, exp = exgroups[GRP_LiveCorrupt]; (exp); exp = exp->link_all)
	{
		/* Don't show hidden players */
		if (((pptr = exp->psp->plp)->flags & PF_Hidden) || (exp->fl & PF_OffTheHook)) continue;
		p = (colour = 1 - colour) ? "#ffaa88" : "#ffaa88";
		if (!z++) fputs(LF "<p><table cols=6 cellspacing=4 cellpadding=4 border=1>"
						LF "<thead><td>Rank:</td><td>Title:</td><td>Name:</td>"
						LF "<td>College:</td><td>Address:</td><td>Comments:</td></thead>", fp);
		fprintf(fp, LF "<tr><td bgcolor=%s><font color="FCOL">%s</font></td>"
					LF "<td bgcolor=%s><font color="FCOL">", p, rank_name[LIM_RANK(exp->rank)], p);
		if (exp->dps) encapsulate(exp->dps->text, fp);
		fprintf(fp, "</font></td><td bgcolor=%s><font color="FCOL">%s", p, pptr->name);
		if (pptr->flags & PF_Mailable) fprintf(fp, " [<a href=\"mailto:%s\">e-mail</a>]", pptr->email);
		fprintf(fp, "</font></td>" LF "<td bgcolor=%s><font color="FCOL">%s</font></td>"
				LF "<td bgcolor=%s><font color="FCOL">%s</font></td>", p, pptr->coll, p, pptr->addr);
		q = ((exp->comment) && (*exp->comment)) ? exp->comment : 0;
		if (!(pptr->flags & PF_LongComment))
		{
			fprintf(fp, "<td bgcolor=%s><font color="FCOL">%s</font></td></tr>", p, pptr->mafia);
			if (q) fprintf(fp, LF "<tr><td colspan=6 bgcolor=%s><font color="FCOL">%s</font></td></tr>", p, q);
		}
		else fprintf(fp, "<td></td></tr><tr><td colspan=6 bgcolor=%s><font color="FCOL">%s%s%s</font></td></tr>",
						 p, pptr->mafia, (q) ? "<br>" : "", NSTR(q));
	}

	if (!z) fputs(LF "<!--#include file=\"" FRAG_URL "npol3none.txt\" -->", fp);
	else fputs(LF "</table></p><!--#include file=\"" FRAG_URL "npol3.txt\" -->", fp);

	/* Run through dead unwanted police */
	for (z = 0, exp = exgroups[GRP_DeadPolice]; (exp); exp = exp->link_all)
	{
		/* Don't show hidden players */
		if ((pptr = exp->psp->plp)->flags & PF_Hidden) continue;
		p = (colour = 1 - colour) ? "#ffbbbb" : "#dd9999";
		if (!z++) fputs(LF "<p><table cols=4 cellspacing=4 cellpadding=4 border=1>"
						LF "<thead><td>Rank:</td><td>Title:</td><td>Name:</td>"
						LF "<td>College:</td></thead>", fp);
		fprintf(fp, LF "<tr><td bgcolor=%s><font color="FCOL">%s</font></td>"
					LF "<td bgcolor=%s><font color="FCOL">", p, rank_name[LIM_RANK(exp->rank)], p);
		if (exp->dps) encapsulate(exp->dps->text, fp);
		fprintf(fp, "</font></td><td bgcolor=%s><font color="FCOL">%s", p, pptr->name);
		if (pptr->flags & PF_Mailable) fprintf(fp, " [<a href=\"mailto:%s\">e-mail</a>]", pptr->email);
		fprintf(fp, "</font></td>" LF "<td bgcolor=%s><font color="FCOL">%s</font></td></tr>", p, pptr->coll);
	}

	if (!z) fputs(LF "<!--#include file=\"" FRAG_URL "npol4none.txt\" -->", fp);
	else fputs(LF "</table></p><!--#include file=\"" FRAG_URL "npol4.txt\" -->", fp);

	/* HTML footer */
	fputs(FRAG_POLICE_HTML_FOOTER, fp);

	/* Finish headline HTML document */
	docfoot(fp, lastperp, 3);

#ifndef http

	/* Close file */
	fclose(fp);

#endif

	/* Debug output */
	fprintf(stderr, "%li:   Police list written.\n", uniqid);

	return 0;
}

int writeincomp(struct period* lastperp)
{
	pexist_p exp, *expp;
	player_p pptr;
	ppseud_p pseudp;
	FILE* fp = stdout;
	int i, colour = 0, z;
	char *p, *q;

#ifndef http

	/* Build new filename */
	sprintf(newsleaf, "incomp.html");

	/* Create and open the new file */
	if (!(fp = fopen(newsfile, "wb"))) return ERF_fopenNews;

#endif

	/* HTML header */
	fputs(FRAG_INCOMP_HTML_HEADER, fp);

	/* Run through live incompetents */
	for (z = 0, exp = exgroups[GRP_LiveIncomp]; (exp); exp = exp->link_all)
	{
		/* Don't show hidden players or redeemed incompetents */
		if (((pptr = exp->psp->plp)->flags & PF_Hidden) || (exp->fl & PF_OffTheHook)) continue;
		p = (colour = 1 - colour) ? "#FFEBBB" : "#E0D580";
		if (!z++) fputs(LF "<p><table cols=5 cellspacing=4 cellpadding=4 border=1>"
						LF "<thead><td>Title:</td><td>Name:</td><td>College:</td>"
						LF "<td>Address:</td><td>Comments:</td></thead>", fp);
		fprintf(fp, LF "<tr><td bgcolor=%s><font color="FCOL">", p);
		if (exp->dps) encapsulate(exp->dps->text, fp);
		fprintf(fp, "</font></td>" LF "<td bgcolor=%s><font color="FCOL">%s</font></td>"
					LF "<td bgcolor=%s><font color="FCOL">%s</font></td>"
					LF "<td bgcolor=%s><font color="FCOL">%s</font></td>",
					p, pptr->name, p, pptr->coll, p, pptr->addr);
		q = ((exp->comment) && (*exp->comment)) ? exp->comment : 0;
		if (!(pptr->flags & PF_LongComment))
		{
			fprintf(fp, "<td bgcolor=%s><font color="FCOL">%s</font></td></tr>", p, pptr->mafia);
			if (q) fprintf(fp, LF "<tr><td colspan=5 bgcolor=%s><font color="FCOL">%s</font></td></tr>", p, q);
		}
		else fprintf(fp, "<td></td></tr><tr><td colspan=5 bgcolor=%s><font color="FCOL">%s%s%s</font></td></tr>",
						 p, pptr->mafia, (q) ? "<br>" : "", NSTR(q));
	}

	if (!z) fputs(LF "<!--#include file=\"" FRAG_URL "ninc2none.txt\" -->", fp);
	else fputs(LF "</table></p><!--#include file=\"" FRAG_URL "ninc2.txt\" -->", fp);

	/* Run through live incompetent police */
	for (z = 0, exp = exgroups[GRP_LiveIncPolice]; (exp); exp = exp->link_all)
	{
		/* Don't show hidden players */
		if (((pptr = exp->psp->plp)->flags & PF_Hidden) || (exp->fl & PF_OffTheHook)) continue;
		p = (colour = 1 - colour) ? "#6EED8E" : "#63D580";
		if (!z++) fputs(LF "<p><table cols=6 cellspacing=4 cellpadding=4 border=1>"
						LF "<thead><td>Rank:</td><td>Title:</td><td>Name:</td>"
						LF "<td>College:</td><td>Address:</td><td>Comments:</td></thead>", fp);
		fprintf(fp, LF "<tr><td bgcolor=%s><font color="FCOL">%s</font></td>"
					LF "<td bgcolor=%s><font color="FCOL">", p, rank_name[LIM_RANK(exp->rank)], p);
		if (exp->dps) encapsulate(exp->dps->text, fp);
		fprintf(fp, "</font></td><td bgcolor=%s><font color="FCOL">%s", p, pptr->name);
		if (pptr->flags & PF_Mailable) fprintf(fp, " [<a href=\"mailto:%s\">e-mail</a>]", pptr->email);
		fprintf(fp, "</font></td>" LF "<td bgcolor=%s><font color="FCOL">%s</font></td>"
				LF "<td bgcolor=%s><font color="FCOL">%s</font></td>", p, pptr->coll, p, pptr->addr);
		q = ((exp->comment) && (*exp->comment)) ? exp->comment : 0;
		if (!(pptr->flags & PF_LongComment))
		{
			fprintf(fp, "<td bgcolor=%s><font color="FCOL">%s</font></td></tr>", p, pptr->mafia);
			if (q) fprintf(fp, LF "<tr><td colspan=6 bgcolor=%s><font color="FCOL">%s</font></td></tr>", p, q);
		}
		else fprintf(fp, "<td></td></tr><tr><td colspan=6 bgcolor=%s><font color="FCOL">%s%s%s</font></td></tr>",
						 p, pptr->mafia, (q) ? "<br>" : "", NSTR(q));
	}

	if (!z) fputs(LF "<!--#include file=\"" FRAG_URL "ninc3none.txt\" -->", fp);
	else fputs(LF "</table></p><!--#include file=\"" FRAG_URL "ninc3.txt\" -->", fp);

	/* Run through dead incompetents */
	for (z = 0, exp = exgroups[GRP_DeadIncomp]; (exp); exp = exp->link_all)
	{
		/* Don't show hidden players */
		if ((pptr = exp->psp->plp)->flags & PF_Hidden) continue;
		p = (colour = 1 - colour) ? "#B1C772" : "#EFC370";
		if (!z++) fputs(LF "<p><table cols=4 cellspacing=4 cellpadding=4 border=1>"
						LF "<thead><td></td><td>Pseudonym:</td><td>Name:</td>"
						LF "<td>College:</td></thead>", fp);
		if (!(exp->fl & PF_Police)) fprintf(fp, LF "<tr><td></td><td bgcolor=%s><font color="FCOL">", p);
		else fprintf(fp, LF "<tr><td bgcolor=%s><font color="FCOL">%s</font></td>"
						 LF "<td bgcolor=%s><font color="FCOL">", p, rank_name[LIM_RANK(exp->rank)], p);
		if (exp->dps) encapsulate(exp->dps->text, fp);
		fprintf(fp, "</font></td>" LF "<td bgcolor=%s><font color="FCOL">%s</font></td>"
				LF "<td bgcolor=%s><font color="FCOL">%s</font></td></tr>", p, pptr->name, p, pptr->coll);
		q = ((exp->comment) && (*exp->comment)) ? exp->comment : 0;
		if (q) fprintf(fp, LF "<tr><td colspan=4 bgcolor=%s><font color="FCOL">%s</font></td></tr>", p, q);
	}

	if (!z) fputs(LF "<!--#include file=\"" FRAG_URL "ninc4none.txt\" -->", fp);
	else fputs(LF "</table></p><!--#include file=\"" FRAG_URL "ninc4.txt\" -->", fp);

	/* HTML footer */
	fputs(FRAG_INCOMP_HTML_FOOTER, fp);

	/* Finish headline HTML document */
	docfoot(fp, lastperp, 7);

#ifndef http

	/* Close file */
	fclose(fp);

#endif

	/* Debug output */
	fprintf(stderr, "%li:   Incompetents' list written.\n", uniqid);

	return 0;
}

int writewanted(struct period* lastperp)
{
	pexist_p exp, *expp;
	player_p pptr;
	ppseud_p pseudp;
	FILE* fp = stdout;
	int i, colour = 0, z;
	char *p, *q;

#ifndef http

	/* Build new filename */
	sprintf(newsleaf, "wanted.html");

	/* Create and open the new file */
	if (!(fp = fopen(newsfile, "wb"))) return ERF_fopenNews;

#endif

	/* HTML header */
	fputs(FRAG_WANTED_HTML_HEADER, fp);

	/* Run through live criminals */
	for (z = 0, exp = exgroups[GRP_LiveWanted]; (exp); exp = exp->link_all)
	{
		/* Don't show hidden players or redeemed criminals */
		if (((pptr = exp->psp->plp)->flags & PF_Hidden) || (exp->fl & PF_OffTheHook)) continue;
		p = (colour = 1 - colour) ? "#FFE5C9" : "#EBD3B9";
		if (!z++) fputs(LF "<p><table cols=5 cellspacing=4 cellpadding=4 border=1>"
						LF "<thead><td>Pseudonym:</td><td>Name:</td>"
						LF "<td>College:</td><td>Address:</td><td>Comments:</td></thead>", fp);
		fprintf(fp, LF "<tr><td bgcolor=%s><font color="FCOL">", p);
		if (exp->dps) encapsulate(exp->dps->text, fp);
		fprintf(fp, "</font></td>" LF "<td bgcolor=%s><font color="FCOL">%s</font></td>"
					LF "<td bgcolor=%s><font color="FCOL">%s</font></td>"
					LF "<td bgcolor=%s><font color="FCOL">%s</font></td>",
					p, pptr->name, p, pptr->coll, p, pptr->addr);
		q = ((exp->comment) && (*exp->comment)) ? exp->comment : 0;
		if (!(pptr->flags & PF_LongComment))
		{
			fprintf(fp, "<td bgcolor=%s><font color="FCOL">%s</font></td></tr>", p, pptr->mafia);
			if (q) fprintf(fp, LF "<tr><td colspan=5 bgcolor=%s><font color="FCOL">%s</font></td></tr>", p, q);
		}
		else fprintf(fp, "<td></td></tr><tr><td colspan=5 bgcolor=%s><font color="FCOL">%s%s%s</font></td></tr>",
						 p, pptr->mafia, (q) ? "<br>" : "", NSTR(q));
	}

	if (!z) fputs(LF "<!--#include file=\"" FRAG_URL "nwant2none.txt\" -->", fp);
	else fputs(LF "</table></p><!--#include file=\"" FRAG_URL "nwant2.txt\" -->", fp);

	/* Run through dead criminals */
	for (z = 0, exp = exgroups[GRP_DeadWanted]; (exp); exp = exp->link_all)
	{
		/* Don't show hidden players */
		if ((pptr = exp->psp->plp)->flags & PF_Hidden) continue;
		p = (colour = 1 - colour) ? "#ffdddd" : "#EBC7EB";
		if (!z++) fputs(LF "<p><table cols=4 cellspacing=4 cellpadding=4 border=1>"
						LF "<thead><td>Pseudonym:</td><td>Name:</td>"
						LF "<td>College:</td><td>Crime:</td></thead>", fp);
		fprintf(fp, LF "<tr><td bgcolor=%s><font color="FCOL">", p);
		if (exp->dps) encapsulate(exp->dps->text, fp);
		fprintf(fp, "</font></td>" LF "<td bgcolor=%s><font color="FCOL">%s"
					"</font></td>" LF "<td bgcolor=%s><font color="FCOL">%s</font></td>"
					LF "<td bgcolor=%s><font color="FCOL">%s</font></td></tr>", p, pptr->name,
					p, pptr->coll, p, ((exp->comment) && (*exp->comment)) ? exp->comment : "");
	}

	if (!z) fputs(LF "<!--#include file=\"" FRAG_URL "nwant3none.txt\" -->", fp);
	else fputs(LF "</table></p><!--#include file=\"" FRAG_URL "nwant3.txt\" -->", fp);

	/* Run through redeemed criminals */
	for (z = 0, exp = exgroups[GRP_LiveWanted]; (exp); exp = exp->link_all)
	{
		/* Don't show hidden players or those not actually redeemed (still the current existence) */
		if (((pptr = exp->psp->plp)->flags & PF_Hidden) || !(exp->fl & PF_OffTheHook)) continue;
		p = (colour = 1 - colour) ? "#DDffdd" : "#bbddbb";
		if (!z++) fputs(LF "<p><table cols=4 cellspacing=4 cellpadding=4 border=1>"
						LF "<thead><td>Pseudonym:</td><td>Case history</td></thead>", fp);
		fprintf(fp, LF "<tr><td bgcolor=%s><font color="FCOL">", p);
		if (exp->dps) encapsulate(exp->dps->text, fp);
		fprintf(fp, "</font></td>" LF "<td bgcolor=%s><font color="FCOL">%s</font></td></tr>",
					p, ((exp->comment) && (*exp->comment)) ? exp->comment : "");
	}

	if (!z) fputs(LF "<!--#include file=\"" FRAG_URL "nwant4none.txt\" -->", fp);
	else fputs(LF "</table></p><!--#include file=\"" FRAG_URL "nwant4.txt\" -->", fp);

	/* HTML footer */
	fputs(FRAG_WANTED_HTML_FOOTER, fp);

	/* Finish headline HTML document */
	docfoot(fp, lastperp, 2);

#ifndef http

	/* Close file */
	fclose(fp);

#endif

	/* Debug output */
	fprintf(stderr, "%li:   Wanted list written.\n", uniqid);

	return 0;
}

/***************************************************************************************************************************
** Categorise and order player "existences"                                                                               **
***************************************************************************************************************************/
int sortexist_fn(void* pppp, void *qqqq)
{
	timeval t1, t2;
	long i, f;
	long ta, tb;

	/* Pointers to the two structs */
	pexist_p ex1p = *((pexist_p*) pppp);
	pexist_p ex2p = *((pexist_p*) qqqq);

	/* Equality? */
	if (ex1p == ex2p) return 0;

	/* Grouping */
	f = flgroup[PF_group(ex1p->fl)];

	/* Same type? */
	if (i = f - flgroup[PF_group(ex2p->fl)]) return (i);

	/* Sort by time of death? */
	if ((f == GRP_DeadPolice) || (f == GRP_DeadWanted)|| (f == GRP_DeadIncomp)) { t1 = ex1p->died; t2 = ex2p->died; }

	/* Sort by most recent time of wantedness? */
	else if ((f == GRP_LiveWanted) || (f == GRP_LiveCorrupt) ||
			 (f == GRP_LiveIncomp) || (f == GRP_LiveIncPolice)) { t1 = ex1p->twant; t2 = ex2p->twant; }

	/* Sort by rank */
	else if (f == GRP_LivePolice)
	{
		if (i = ex2p->rank - ex1p->rank) return (i);
		t1 = ex1p->tpol;
		t2 = ex2p->tpol;
	}

	/* Sort by time of incarnation */
	else { t1 = ex1p->born; t2 = ex2p->born; }

	/* Do the sort */
	return ((t1 - t2) ? ((t1 > t2) ? +1 : -1) : 0);
}

int sortexist(struct evolve__results *er)
{
	pexist_p exp, *exists;
	int tgrp, pgrp, i, n;

	/* Allocate array of pointers */
	if (!(exists = malloc(er->existcnt * sizeof(pexist_p)))) return ERF_mallocFailed;

	/* Initialise array */
	for (i = 0, exp = er->elist; (exp); exp = exp->link_all)
	{
		if (i >= er->existcnt) return ERF_InternalError;
		exists[i++] = exp;
	}

	/* Sort array */
	qsort(exists, i, sizeof(pexist_p), (sortexist__ftype) sortexist_fn);

	/* Initialise grouping lists */
	for (n = 0; (n < GRP_MAX); n++) exgroups[n] = 0;

	/* Partition into distinct groupings */
	for (pgrp = -1, n = 0; (n < i); n++)
	{
		/* Old group */
		if (pgrp == (tgrp = flgroup[PF_group(exists[n]->fl)])) exp->link_all = exists[n];

		/* New group */
		else exgroups[pgrp = tgrp] = exists[n];

		/* Last in group */
		(exp = exists[n])->link_all = 0;
	}

	/* Free the temporary array */
	free(exists);

	/* Progress */
	fprintf(stderr, "%li:   Sorting complete.\n", uniqid);

	/* Sorted */
	return 0;
}

/***************************************************************************************************************************
** Main code. Doesn't make use of command line arguments.                                                                 **
***************************************************************************************************************************/
int main(int argc, char* argv[])
{
	char buf[MAX_buf], *buf_end = (buf + MAX_buf - 1), *buf_pos = buf;
	int rc = 0, lockfd = 0, i;
	struct news_context ctx;
	struct evolve__results erout;

	/* Be careful with initialisation */
	ctx.fhead = 0;

	/* Debug: no buffering on stdout */
	/* setbuf(stdout, 0); */

/* Live, cgi mode */
#ifdef http

	/* Output HTTP headers */
    printf("Content-type: text/html" LF LF);

	/* Initialse stuff: time, file creation umask, pid, make note in log and redirect stderr there */
	if ((rc = geninit(&thetimestr, 0117, 1, "mknews")) < 0) exit(send_doc(-rc, 0));

	/* Logged error handler now established */
	else if (rc) erf(rc, 1);

	/* Parse CGI input */
	if ((i = parsecgi()) > 0) erf(i, 2);

	/* Require password */
	if (strcmp(findval("security", 1), SECURITY)) exit(insecure(8, "news"));

	/* CGI mode - always up to date */
	mode = MODE_Priv | MODE_EvLink | MODE_CGI | MODE_NewsOnStdout;

	/* XXX XXX Allow selection by date? XXX XXX */

	/* No period restriction? Cover all periods */
	if (!(p = findval("which", 0)) || ((i = atoi(p)) < -7) || (i == 0)) ctx.perp = 0;

	/* Only headlines? */
	else if (i == -1) mode = MODE_Priv | MODE_EvLink | MODE_CGI | MODE_HEAD;

	/* Only police list? */
	else if (i == -2) mode = MODE_Priv | MODE_EvLink | MODE_CGI | MODE_POL;

	/* Only show wanted list? */
	else if (i == -3) mode = MODE_Priv | MODE_EvLink | MODE_CGI | MODE_WANT;

	/* Only show headlines by addition date? */
	else if (i == -4) mode = MODE_Priv | MODE_EvLink | MODE_CGI | MODE_CHANGES;

	/* Only show incompetents list? */
	else if (i == -5) mode = MODE_Priv | MODE_EvLink | MODE_CGI | MODE_INCOMP;

	/* Only show link fragment? */
	else if (i == -6) mode = MODE_Priv | MODE_EvLink | MODE_CGI | MODE_FRAGMENT;

	/* Only show scores fragment? */
	else if (i == -7) mode = MODE_Priv | MODE_EvLink | MODE_CGI | MODE_SCORES;

	/* Acquire period pointer */
	else for (ctx.perp = &periods[0]; (--i); ctx.perp++) if (ctx.perp->tmax >= TMAX) break;

	/* Use stdout as headlines file (otherwise ctx.fhead = 0) */
	if (mode & MODE_HEAD) ctx.fhead = stdout;

/* Background mode */
#else

	/* Initialse stuff: time, file creation umask, pid, no title, don't redirect stderr */
	if ((rc = geninit(&thetimestr, 0113, 0, 0)) < 0) exit(send_doc(-rc));

	/* Collect errors */
	else if (rc) erf(rc, 6);

	/* Point to leafname */
	newsleaf = &newsfile[strlen(newsfile) - 9];

	/* Print status */
	fprintf(stderr, "%li ** \"mknews\" ", uniqid);

	/* Spool mode - cache news and all other pages */
	mode = /*MODE_POL|MODE_SCORES|*/MODE_WANT|MODE_INCOMP|/*MODE_FRAGMENT|*/
		   MODE_CHANGES|MODE_HEAD|MODE_NewsToFiles|MODE_EvLink|/*MODE_Accurate|*/MODE_Warn;

	/* Check command line flags */
	for (i = 1; (i < argc); i++) if ((argv[i][0] == '+') || (argv[i][0] == '-') || (argv[i][0] == '^'))
	{
		/* No effect for unknown switches */
		mode_type mf = 0;

		/* Only first letter of command switches is matched */
		switch (tolower(argv[i][1]))
		{
			case '1': mf = MODE_HEAD;		break;
			case '2': mf = MODE_POL;		break;
			case '3': mf = MODE_WANT;		break;
			case '4': mf = MODE_CHANGES;	break;
			case '5': mf = MODE_INCOMP;		break;
			case '6': mf = MODE_FRAGMENT;	break;
			case '7': mf = MODE_SCORES;		break;
			case 'p': mf = MODE_Priv;		break;
			case 'd': mf = MODE_Debug;		break;
			case 'w': mf = MODE_Warn;		break;
			case 'a': mf = MODE_Accurate;	break;
			case 'l': mf = MODE_EvLink;		break;
		}

		/* Print flag status */
		if (mf) fprintf(stderr, "%c%c", argv[i][0], argv[i][1]);

		/* +X to set flag */
		if (argv[i][0] == '+') mode |= mf;

		/* -X to clear flag */
		else if (argv[i][0] == '-') mode &= ~mf;

		/* ^X to toggle flag */
		else mode ^= mf;
	}

	/* Finish printing status */
	fprintf(stderr, " &%x --> %s\n", mode, newsfile);

	/* Cover all periods */
	ctx.perp = 0;

	/* Open headlines file (otherwise ctx.fhead = 0) */
	if ((mode & MODE_HEAD) && (!(ctx.fhead = fopen(newsfile, "wb")))) erf(ERF_fopenNews, 9);

#endif

	/* Acquire lock */
	if (!(lockfd = setflock("mknews.c "))) erf(ERF_flockFailed, 10);

	/* Load player information */
	if (rc = uread(0, news_uread_func, 0, buf, buf_end, &buf_pos, &ctx, 0)) erf(rc, 11);

	/* Load and prepare reports (rptr->fpos fields to give offset of report text in file) */
	if ((mode & (MODE_NEWS)) && (rc = repfile(&replist, plist, &buf_pos, buf_end, &freps, 0))) erf(rc, 12);

	/* Headline HTML header */
	if ((ctx.fhead) && (EOF == fputs(FRAG_HEADLINE_HTML_HEADER, ctx.fhead))) erf(ERF_fputsFailed, 12);

	/* No periods encountered yet */
	ctx.lastperp = 0;
	ctx.day = -1;

	/* News on standard output? */
	if (ctx.fnews = (mode & MODE_NewsOnStdout) ? stdout : 0)
	{
		/* Start single period of HTML news on stdout */
		if (ctx.perp) printf(LF "<HTML><HEAD><TITLE>" GAME " Live Game News - %s</TITLE></HEAD>"
							 LF "<BODY " COLSCHEME ">" LF "<h1><hr>" GAME " Live Game News - %s<hr></h1>" LF,
							 ctx.perp->title, ctx.perp->title);
	
		/* Start complete HTML news on stdout */
		else printf(LF "<HTML><HEAD><TITLE>" GAME " Live Game News</TITLE></HEAD>"
					LF "<BODY " COLSCHEME ">" LF "<h1><hr>" GAME " Live Game News<hr></h1>" LF);
	}

	/* Evolve game and write news */
	if (rc = evolve(EVOLVE_MatchAll|EVOLVE_FuncNews|EVOLVE_InheritPseud|EVOLVE_BacklinkPlayers|
					EVLadd_AllPseuds|EVLadd_Comments|EVLadd_AllExists, 0,0, &pstlist, 0,0,0,0,0,0,0,0,
					buf_pos, buf_end, &buf_pos, news_evolve_hook, &ctx, plist, 0, 0, &erout)) erf(rc, 20);

	/* Debug output */
	fprintf(stderr, "%li:   Event iterations complete\n", uniqid);

	/* Finalisation - Complete previous period documents */
	if ((mode & MODE_NewsToFiles) && (ctx.fnews) && (ctx.lastperp))
	{
		/* Finish old news HTML document */
		docfoot(ctx.fnews, ctx.lastperp, 0); /* erf(21) */

		/* Close old news */
		if (!fclose(ctx.fnews)) ctx.fnews = 0; else erf(ERF_fcloseFailed, 22);
	}

	/* Finalise HTML news on stdout */
	else if (mode & MODE_NewsOnStdout)
	{
		/* Finish single period of HTML news on stdout */
		if (ctx.perp) docfoot(stdout, ctx.perp, 0); /* erf(22) */

		/* Finish complete HTML news on stdout */
		else docfoot(stdout, ctx.lastperp, 1); /* erf(23) */
	}

	/* Finish headline HTML document */
	if (ctx.fhead)
	{
		if (EOF == fputs(FRAG_HEADLINE_HTML_FOOTER, ctx.fhead)) erf(ERF_fputsFailed, 24);
		docfoot(ctx.fhead, ctx.lastperp, 4); /* erf(25) */
	}

	/* Write headlines sorted by date of addition */
	if ((mode & MODE_CHANGES) && (rc = writeheadch(ctx.lastperp))) erf(rc, 26);

	/* Categorise and order player existences */
	if ((mode & (MODE_WANT|MODE_POL|MODE_INCOMP)) && (rc = sortexist(&erout))) erf(rc, 27);

	/* Write wanted list */
	if ((mode & MODE_WANT) && (rc = writewanted(ctx.lastperp))) erf(rc, 28);

	/* Write police list */
	if ((mode & MODE_POL) && (rc = writepolice(ctx.lastperp))) erf(rc, 29);

	/* Write incompetents list */
	if ((mode & MODE_INCOMP) && (rc = writeincomp(ctx.lastperp))) erf(rc, 30);

	/* Write fragment containing scores */
	/*if ((mode & MODE_SCORES)) && (rc = writescores())) erf(rc, 31);*/

	/* Write fragment containing news links */
	/*if ((mode & MODE_FRAGMENT)) && (rc = writefragment())) erf(rc, 32);*/


_erf: /***** Error handling *****/

	/* Debug */
	if (rc) fprintf(stderr, "%li !! main(%i):%i\n", uniqid, ERF_CONTEXT(rc), ERF_TYPE(rc));

	/* Tidy up */
	if ((ctx.fhead) && (ctx.fhead != stdout)) fclose(ctx.fhead);
	if (freps) fclose(freps);
	if (lockfd) setfunlock(lockfd);

	/* Only retain low bits of normal rc's */
	return(send_doc(ERF_LOWBITS(rc)));
}

/***************************************************************************************************************************
** Output document footers: 'fl' = 0/1 for single/all news, 2/3/4/6 for wanted/police/headlines/updates.                  **
***************************************************************************************************************************/
void docfoot(FILE* fp, struct period *ppt, int fl)
{
	struct period *pp = &periods[0];
	char *p1, *p2, *p3, *p4, *p5, *pn;

	if (mode & MODE_CGI) return;

	p1 = "<a href=\"" NEWS_URL "wanted.html\">";
	p2 = "<a href=\"" NEWS_URL "police.html\">";
	p3 = "<a href=\"" NEWS_URL "head.html\">";
	p4 = "<a href=\"" NEWS_URL "hups.html\">";
	p5 = "<a href=\"" NEWS_URL "incomp.html\">";
	pn = "<a href=\"" NEWS_URL "news";

	if (fl != 5)
	{
		fprintf(fp, LF "<!--#include file=\"" FRAG_URL "foot1.txt\" -->"
					/*LF "<a href=\"" NEWS_INDEX "\">Index</a> ]"*/
					/*LF "| %sWanted List%s"*/
					/*LF "| %sIncompetents%s"*/
					/*LF "| %sPolice%s"*/
					LF "%sHeadlines%s"
					LF "| %sUpdates%s"
					LF "<!--#include file=\"" FRAG_URL "foot2.txt\" -->"
					LF "<p align=right>Produced at %s</p></BODY></HTML>\n",
				/*(fl == 2) ? "" : p1, (fl == 2) ? "" : "</a>",*/
				/*(fl == 7) ? "" : p5, (fl == 7) ? "" : "</a>",*/
				/*(fl == 3) ? "" : p2, (fl == 3) ? "" : "</a>",*/
				(fl == 4) ? "" : p3, (fl == 4) ? "" : "</a>",
				(fl == 6) ? "" : p4, (fl == 6) ? "" : "</a>",
				thetimestr);
	}
}

/***************************************************************************************************************************
** Output error documents, etc.
***************************************************************************************************************************/
int send_doc(int which)
{

#ifndef http

	if (which) fprintf(stderr, "%li !! return code %i.\n", uniqid, which);
	return which;

#endif

	error_doc(which);
	return 0;
}

/***** The end *****/
